#include "ppaa02.header.cxx"
void ppaa02_list_subprocess_born(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppaa02_list_subprocess_born");
  logger << LOG_DEBUG << "called" << endl;
  if (contribution_order_alpha_s == 0 && contribution_order_alpha_e == 2 && contribution_order_interference == 0){
    subprocess.resize(3);
    subprocess[1] = "dd~_aa";
    subprocess[2] = "uu~_aa";
    int member_0[] = {1, 2};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  else if (contribution_order_alpha_s == 2 && contribution_order_alpha_e == 2 && contribution_order_interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_aa";
    int member_0[] = {1};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  logger << LOG_DEBUG << "finished" << endl;
}
void ppaa02_list_subprocess_C_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppaa02_list_subprocess_C_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_aa";
  subprocess[2] = "uu~_aa";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppaa02_list_subprocess_V_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppaa02_list_subprocess_V_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_aa";
  subprocess[2] = "uu~_aa";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppaa02_list_subprocess_R_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppaa02_list_subprocess_R_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_aad";
  subprocess[2] = "gu_aau";
  subprocess[3] = "gd~_aad~";
  subprocess[4] = "gu~_aau~";
  subprocess[5] = "dd~_aag";
  subprocess[6] = "uu~_aag";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppaa02_list_subprocess_RC_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppaa02_list_subprocess_RC_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_aad";
  subprocess[2] = "gu_aau";
  subprocess[3] = "gd~_aad~";
  subprocess[4] = "gu~_aau~";
  subprocess[5] = "dd~_aag";
  subprocess[6] = "uu~_aag";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppaa02_list_subprocess_RV_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppaa02_list_subprocess_RV_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_aad";
  subprocess[2] = "gu_aau";
  subprocess[3] = "gd~_aad~";
  subprocess[4] = "gu~_aau~";
  subprocess[5] = "dd~_aag";
  subprocess[6] = "uu~_aag";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppaa02_list_subprocess_RR_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppaa02_list_subprocess_RR_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(35);
  subprocess[1] = "gg_aadd~";
  subprocess[2] = "gg_aauu~";
  subprocess[3] = "gd_aagd";
  subprocess[4] = "gu_aagu";
  subprocess[5] = "gd~_aagd~";
  subprocess[6] = "gu~_aagu~";
  subprocess[7] = "dd_aadd";
  subprocess[8] = "du_aadu";
  subprocess[9] = "ds_aads";
  subprocess[10] = "dc_aadc";
  subprocess[11] = "dd~_aagg";
  subprocess[12] = "dd~_aadd~";
  subprocess[13] = "dd~_aauu~";
  subprocess[14] = "dd~_aass~";
  subprocess[15] = "dd~_aacc~";
  subprocess[16] = "du~_aadu~";
  subprocess[17] = "ds~_aads~";
  subprocess[18] = "dc~_aadc~";
  subprocess[19] = "uu_aauu";
  subprocess[20] = "uc_aauc";
  subprocess[21] = "ud~_aaud~";
  subprocess[22] = "uu~_aagg";
  subprocess[23] = "uu~_aadd~";
  subprocess[24] = "uu~_aauu~";
  subprocess[25] = "uu~_aass~";
  subprocess[26] = "uu~_aacc~";
  subprocess[27] = "us~_aaus~";
  subprocess[28] = "uc~_aauc~";
  subprocess[29] = "d~d~_aad~d~";
  subprocess[30] = "d~u~_aad~u~";
  subprocess[31] = "d~s~_aad~s~";
  subprocess[32] = "d~c~_aad~c~";
  subprocess[33] = "u~u~_aau~u~";
  subprocess[34] = "u~c~_aau~c~";
  int member_0[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
