logger << LOG_DEBUG_VERBOSE << "user/specify.cuts.cxx started" << endl;
{
  static stringstream info_cut;
  if (osi_switch_output_cutinfo){
    info_cut.clear();
    info_cut.str("");
    for (int i_p = 3; i_p < osi_p_parton[i_a].size(); i_p++){
      info_cut << "[" << setw(2) << i_a << "]   type_parton[" << i_p << "] = " << setw(3) << osi_type_parton[i_a][i_p] << " -> " << osi_particle_event[0][i_a][i_p].momentum << " pT = " << osi_particle_event[0][i_a][i_p].pT << " eta = " << osi_particle_event[0][i_a][i_p].eta << endl;
    }
    for (int i_o = 0; i_o < osi_esi.object_list_selection.size(); i_o++){
      int j_o = osi_equivalent_no_object[i_o]; 
      // i_o -> number in relevant_object_list
      // j_o -> number in object_list
      //    int j_o = osi_no_relevant_object[osi_esi.object_list_selection[i_o]]; // i_o -> number in relevant_object_list; j_o -> i_o
      info_cut << "[" << setw(2) << i_a << "]   osi_esi.object_list_selection[" << setw(2) << i_o << "] = " << setw(6) << osi_esi.object_list_selection[i_o] << "   osi_n_object[" << setw(2) << j_o << "][" << setw(2) << i_a << "] = " << osi_n_object[j_o][i_a] << "   osi_particle_event[" << setw(2) << j_o << "][" << setw(2) << i_a << "].size() = " << osi_particle_event[j_o][i_a].size() << endl;
      for (int i_p = 0; i_p < osi_n_object[j_o][i_a]; i_p++){
	info_cut << "       osi_particle_event[" << setw(2) << j_o << "][" << setw(2) << i_a << "][" << setw(2) << i_p << "] = " << osi_particle_event[j_o][i_a][i_p].momentum << endl;
      }
    }
  }

  
  static int switch_cut_R_leplep = osi_user_switch_value[osi_user_switch_map["R_leplep"]];
  static double cut_min_R_leplep = osi_user_cut_value[osi_user_cut_map["min_R_leplep"]];
  static double cut_min_R2_leplep = pow(cut_min_R_leplep, 2);
  
  static int switch_cut_M_leplep = osi_user_switch_value[osi_user_switch_map["M_leplep"]];
  static double cut_min_M_leplep = osi_user_cut_value[osi_user_cut_map["min_M_leplep"]];
  static double cut_min_M2_leplep = pow(cut_min_M_leplep, 2);
    static double cut_max_M_leplep = osi_user_cut_value[osi_user_cut_map["max_M_leplep"]];
  static double cut_max_M2_leplep = pow(cut_max_M_leplep, 2);
  
  if (switch_cut_R_leplep) {
    double R2_eta_leplep = R2_eta(osi_particle_event[osi_access_object["lep"]][i_a][0], osi_particle_event[osi_access_object["lep"]][i_a][1]);
    if (R2_eta_leplep < cut_min_R2_leplep){
      osi_cut_ps[i_a] = -1; 
      logger << LOG_DEBUG_VERBOSE << "switch_cut_R_leplep cut applied" << endl; 
      return;
    }
  }
    
  if (switch_cut_M_leplep) {
    double M2_leplep = (osi_particle_event[osi_access_object["lep"]][i_a][0].momentum + osi_particle_event[osi_access_object["lep"]][i_a][1].momentum).m2();
    // cout<<"*******************"<<cut_min_M2_leplep<<" ***********  "<<cut_max_M2_leplep<<"***********************"<<endl;
    if (M2_leplep < cut_min_M2_leplep){
      osi_cut_ps[i_a] = -1; 
      logger << LOG_DEBUG_VERBOSE << "switch_cut_M_leplep min cut applied" << endl; 
      return;
    }
    
    if (M2_leplep > cut_max_M2_leplep){
      osi_cut_ps[i_a] = -1; 
      logger << LOG_DEBUG_VERBOSE << "switch_cut_M_leplep max cut applied" << endl; 
      return;
    }
  }

  if (osi_switch_output_cutinfo){info_cut << "individual cuts passed" << endl;}

}
logger << LOG_DEBUG_VERBOSE << "user/specify.cuts.cxx ended" << endl;

