void pph21_particles(int i_a, observable_set & oset);

void pph21_cuts(int i_a, observable_set & oset);
void pph21_cuts_test(int i_a, observable_set & oset);

void pph21_moments(observable_set & oset);

void pph21_calculate_dynamic_scale(int i_a, observable_set & oset);
void pph21_calculate_dynamic_scale_RA(int i_a, observable_set & oset);
void pph21_calculate_dynamic_scale_TSV(int i_a, observable_set & oset);

void pph21_optimize_minv_born(phasespace_set & psi);
int pph21_determination_MCchannels_born(int no_ps, phasespace_set & psi);
void pph21_ac_tau_psp_born(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi);
void pph21_ag_psp_born(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_born(int no_ps, phasespace_set & psi);
void pph21_ac_psp_born(int no_ps, int channel, phasespace_set & psi);
void pph21_ax_psp_210_gg_h(int no_ps, phasespace_set & psi);
void pph21_ac_psp_210_gg_h(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_210_gg_h(int no_ps, int zero, phasespace_set & psi);
void pph21_phasespacepoint_born(observable_set & oset);

void pph21_phasespacepoint_collinear(observable_set & oset);

void pph21_optimize_minv_real(phasespace_set & psi);
int pph21_determination_MCchannels_real(int no_ps, phasespace_set & psi);
void pph21_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi);
void pph21_ag_psp_real(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_real(int no_ps, phasespace_set & psi);
void pph21_ac_psp_real(int no_ps, int channel, phasespace_set & psi);
void pph21_ax_psp_310_gg_hg(int no_ps, phasespace_set & psi);
void pph21_ac_psp_310_gg_hg(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_310_gg_hg(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_310_gd_hd(int no_ps, phasespace_set & psi);
void pph21_ac_psp_310_gd_hd(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_310_gd_hd(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_310_gu_hu(int no_ps, phasespace_set & psi);
void pph21_ac_psp_310_gu_hu(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_310_gu_hu(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_310_gdx_hdx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_310_gdx_hdx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_310_gdx_hdx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_310_gux_hux(int no_ps, phasespace_set & psi);
void pph21_ac_psp_310_gux_hux(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_310_gux_hux(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_310_ddx_hg(int no_ps, phasespace_set & psi);
void pph21_ac_psp_310_ddx_hg(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_310_ddx_hg(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_310_uux_hg(int no_ps, phasespace_set & psi);
void pph21_ac_psp_310_uux_hg(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_310_uux_hg(int no_ps, int zero, phasespace_set & psi);
void pph21_phasespacepoint_real(observable_set & oset);

void pph21_phasespacepoint_realcollinear(observable_set & oset);

void pph21_optimize_minv_doublereal(phasespace_set & psi);
int pph21_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi);
void pph21_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi);
void pph21_ag_psp_doublereal(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_doublereal(int no_ps, phasespace_set & psi);
void pph21_ac_psp_doublereal(int no_ps, int channel, phasespace_set & psi);
void pph21_ax_psp_410_gg_hgg(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_gg_hgg(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_gg_hgg(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_gg_hddx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_gg_hddx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_gg_hddx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_gg_huux(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_gg_huux(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_gg_huux(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_gd_hgd(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_gd_hgd(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_gd_hgd(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_gu_hgu(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_gu_hgu(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_gu_hgu(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_gdx_hgdx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_gdx_hgdx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_gdx_hgdx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_gux_hgux(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_gux_hgux(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_gux_hgux(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_dd_hdd(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_dd_hdd(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_dd_hdd(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_du_hdu(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_du_hdu(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_du_hdu(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_ds_hds(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_ds_hds(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_ds_hds(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_dc_hdc(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_dc_hdc(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_dc_hdc(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_ddx_hgg(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_ddx_hgg(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_ddx_hgg(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_ddx_hddx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_ddx_hddx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_ddx_hddx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_ddx_huux(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_ddx_huux(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_ddx_huux(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_ddx_hssx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_ddx_hssx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_ddx_hssx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_ddx_hccx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_ddx_hccx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_ddx_hccx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_dux_hdux(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_dux_hdux(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_dux_hdux(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_dsx_hdsx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_dsx_hdsx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_dsx_hdsx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_dcx_hdcx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_dcx_hdcx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_dcx_hdcx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_uu_huu(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_uu_huu(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_uu_huu(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_uc_huc(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_uc_huc(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_uc_huc(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_udx_hudx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_udx_hudx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_udx_hudx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_uux_hgg(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_uux_hgg(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_uux_hgg(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_uux_hddx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_uux_hddx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_uux_hddx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_uux_huux(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_uux_huux(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_uux_huux(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_uux_hssx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_uux_hssx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_uux_hssx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_uux_hccx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_uux_hccx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_uux_hccx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_usx_husx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_usx_husx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_usx_husx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_ucx_hucx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_ucx_hucx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_ucx_hucx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_dxdx_hdxdx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_dxdx_hdxdx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_dxdx_hdxdx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_dxux_hdxux(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_dxux_hdxux(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_dxux_hdxux(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_dxsx_hdxsx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_dxsx_hdxsx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_dxsx_hdxsx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_dxcx_hdxcx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_dxcx_hdxcx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_dxcx_hdxcx(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_uxux_huxux(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_uxux_huxux(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_uxux_huxux(int no_ps, int zero, phasespace_set & psi);
void pph21_ax_psp_410_uxcx_huxcx(int no_ps, phasespace_set & psi);
void pph21_ac_psp_410_uxcx_huxcx(int no_ps, int channel, phasespace_set & psi);
void pph21_ag_psp_410_uxcx_huxcx(int no_ps, int zero, phasespace_set & psi);
void pph21_phasespacepoint_doublereal(observable_set & oset);

