#include "ppnenex02.header.cxx"
void ppnenex02_list_subprocess_born(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenex02_list_subprocess_born");
  logger << LOG_DEBUG << "called" << endl;
  if (contribution_order_alpha_s == 0 && contribution_order_alpha_e == 2 && contribution_order_interference == 0){
    subprocess.resize(3);
    subprocess[1] = "dd~_veve~";
    subprocess[2] = "uu~_veve~";
    int member_0[] = {1, 2};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  else if (contribution_order_alpha_s == 2 && contribution_order_alpha_e == 2 && contribution_order_interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_veve~";
    int member_0[] = {1};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenex02_list_subprocess_C_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenex02_list_subprocess_C_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_veve~";
  subprocess[2] = "uu~_veve~";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenex02_list_subprocess_V_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenex02_list_subprocess_V_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_veve~";
  subprocess[2] = "uu~_veve~";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenex02_list_subprocess_R_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenex02_list_subprocess_R_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_veve~d";
  subprocess[2] = "gu_veve~u";
  subprocess[3] = "gd~_veve~d~";
  subprocess[4] = "gu~_veve~u~";
  subprocess[5] = "dd~_veve~g";
  subprocess[6] = "uu~_veve~g";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenex02_list_subprocess_RC_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenex02_list_subprocess_RC_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_veve~d";
  subprocess[2] = "gu_veve~u";
  subprocess[3] = "gd~_veve~d~";
  subprocess[4] = "gu~_veve~u~";
  subprocess[5] = "dd~_veve~g";
  subprocess[6] = "uu~_veve~g";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenex02_list_subprocess_RV_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenex02_list_subprocess_RV_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_veve~d";
  subprocess[2] = "gu_veve~u";
  subprocess[3] = "gd~_veve~d~";
  subprocess[4] = "gu~_veve~u~";
  subprocess[5] = "dd~_veve~g";
  subprocess[6] = "uu~_veve~g";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenex02_list_subprocess_RR_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenex02_list_subprocess_RR_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(35);
  subprocess[1] = "gg_veve~dd~";
  subprocess[2] = "gg_veve~uu~";
  subprocess[3] = "gd_veve~gd";
  subprocess[4] = "gu_veve~gu";
  subprocess[5] = "gd~_veve~gd~";
  subprocess[6] = "gu~_veve~gu~";
  subprocess[7] = "dd_veve~dd";
  subprocess[8] = "du_veve~du";
  subprocess[9] = "ds_veve~ds";
  subprocess[10] = "dc_veve~dc";
  subprocess[11] = "dd~_veve~gg";
  subprocess[12] = "dd~_veve~dd~";
  subprocess[13] = "dd~_veve~uu~";
  subprocess[14] = "dd~_veve~ss~";
  subprocess[15] = "dd~_veve~cc~";
  subprocess[16] = "du~_veve~du~";
  subprocess[17] = "ds~_veve~ds~";
  subprocess[18] = "dc~_veve~dc~";
  subprocess[19] = "uu_veve~uu";
  subprocess[20] = "uc_veve~uc";
  subprocess[21] = "ud~_veve~ud~";
  subprocess[22] = "uu~_veve~gg";
  subprocess[23] = "uu~_veve~dd~";
  subprocess[24] = "uu~_veve~uu~";
  subprocess[25] = "uu~_veve~ss~";
  subprocess[26] = "uu~_veve~cc~";
  subprocess[27] = "us~_veve~us~";
  subprocess[28] = "uc~_veve~uc~";
  subprocess[29] = "d~d~_veve~d~d~";
  subprocess[30] = "d~u~_veve~d~u~";
  subprocess[31] = "d~s~_veve~d~s~";
  subprocess[32] = "d~c~_veve~d~c~";
  subprocess[33] = "u~u~_veve~u~u~";
  subprocess[34] = "u~c~_veve~u~c~";
  int member_0[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
