#include "ppnenexa03.header.cxx"
void ppnenexa03_list_subprocess_born(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenexa03_list_subprocess_born");
  logger << LOG_DEBUG << "called" << endl;
  if (contribution_order_alpha_s == 0 && contribution_order_alpha_e == 3 && contribution_order_interference == 0){
    subprocess.resize(3);
    subprocess[1] = "dd~_veve~a";
    subprocess[2] = "uu~_veve~a";
    int member_0[] = {1, 2};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  else if (contribution_order_alpha_s == 2 && contribution_order_alpha_e == 3 && contribution_order_interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_veve~a";
    int member_0[] = {1};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenexa03_list_subprocess_C_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenexa03_list_subprocess_C_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_veve~a";
  subprocess[2] = "uu~_veve~a";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenexa03_list_subprocess_V_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenexa03_list_subprocess_V_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_veve~a";
  subprocess[2] = "uu~_veve~a";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenexa03_list_subprocess_R_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenexa03_list_subprocess_R_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_veve~ad";
  subprocess[2] = "gu_veve~au";
  subprocess[3] = "gd~_veve~ad~";
  subprocess[4] = "gu~_veve~au~";
  subprocess[5] = "dd~_veve~ag";
  subprocess[6] = "uu~_veve~ag";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenexa03_list_subprocess_RC_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenexa03_list_subprocess_RC_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_veve~ad";
  subprocess[2] = "gu_veve~au";
  subprocess[3] = "gd~_veve~ad~";
  subprocess[4] = "gu~_veve~au~";
  subprocess[5] = "dd~_veve~ag";
  subprocess[6] = "uu~_veve~ag";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenexa03_list_subprocess_RV_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenexa03_list_subprocess_RV_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_veve~ad";
  subprocess[2] = "gu_veve~au";
  subprocess[3] = "gd~_veve~ad~";
  subprocess[4] = "gu~_veve~au~";
  subprocess[5] = "dd~_veve~ag";
  subprocess[6] = "uu~_veve~ag";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppnenexa03_list_subprocess_RR_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppnenexa03_list_subprocess_RR_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(35);
  subprocess[1] = "gg_veve~add~";
  subprocess[2] = "gg_veve~auu~";
  subprocess[3] = "gd_veve~agd";
  subprocess[4] = "gu_veve~agu";
  subprocess[5] = "gd~_veve~agd~";
  subprocess[6] = "gu~_veve~agu~";
  subprocess[7] = "dd_veve~add";
  subprocess[8] = "du_veve~adu";
  subprocess[9] = "ds_veve~ads";
  subprocess[10] = "dc_veve~adc";
  subprocess[11] = "dd~_veve~agg";
  subprocess[12] = "dd~_veve~add~";
  subprocess[13] = "dd~_veve~auu~";
  subprocess[14] = "dd~_veve~ass~";
  subprocess[15] = "dd~_veve~acc~";
  subprocess[16] = "du~_veve~adu~";
  subprocess[17] = "ds~_veve~ads~";
  subprocess[18] = "dc~_veve~adc~";
  subprocess[19] = "uu_veve~auu";
  subprocess[20] = "uc_veve~auc";
  subprocess[21] = "ud~_veve~aud~";
  subprocess[22] = "uu~_veve~agg";
  subprocess[23] = "uu~_veve~add~";
  subprocess[24] = "uu~_veve~auu~";
  subprocess[25] = "uu~_veve~ass~";
  subprocess[26] = "uu~_veve~acc~";
  subprocess[27] = "us~_veve~aus~";
  subprocess[28] = "uc~_veve~auc~";
  subprocess[29] = "d~d~_veve~ad~d~";
  subprocess[30] = "d~u~_veve~ad~u~";
  subprocess[31] = "d~s~_veve~ad~s~";
  subprocess[32] = "d~c~_veve~ad~c~";
  subprocess[33] = "u~u~_veve~au~u~";
  subprocess[34] = "u~c~_veve~au~c~";
  int member_0[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
