#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeeexex04/header/ppeeexex04.phasespace.h"
void ppeeexex04_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppeeexex04_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeeexex04_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeeexex04_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 1168;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 496;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 496;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 496;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 496;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 496;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 496;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 576;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 288;}
  else if (psi_no_map[no_ps] == 10){n_channel = 288;}
  else if (psi_no_map[no_ps] == 11){n_channel = 288;}
  else if (psi_no_map[no_ps] == 13){n_channel = 496;}
  else if (psi_no_map[no_ps] == 14){n_channel = 576;}
  else if (psi_no_map[no_ps] == 15){n_channel = 288;}
  else if (psi_no_map[no_ps] == 16){n_channel = 288;}
  else if (psi_no_map[no_ps] == 17){n_channel = 288;}
  else if (psi_no_map[no_ps] == 18){n_channel = 288;}
  else if (psi_no_map[no_ps] == 20){n_channel = 288;}
  else if (psi_no_map[no_ps] == 22){n_channel = 288;}
  else if (psi_no_map[no_ps] == 23){n_channel = 576;}
  else if (psi_no_map[no_ps] == 24){n_channel = 288;}
  else if (psi_no_map[no_ps] == 25){n_channel = 288;}
  else if (psi_no_map[no_ps] == 27){n_channel = 496;}
  else if (psi_no_map[no_ps] == 28){n_channel = 288;}
  else if (psi_no_map[no_ps] == 29){n_channel = 576;}
  else if (psi_no_map[no_ps] == 30){n_channel = 288;}
  else if (psi_no_map[no_ps] == 31){n_channel = 288;}
  else if (psi_no_map[no_ps] == 32){n_channel = 288;}
  else if (psi_no_map[no_ps] == 34){n_channel = 288;}
  else if (psi_no_map[no_ps] == 35){n_channel = 576;}
  else if (psi_no_map[no_ps] == 36){n_channel = 288;}
  else if (psi_no_map[no_ps] == 37){n_channel = 288;}
  else if (psi_no_map[no_ps] == 38){n_channel = 288;}
  else if (psi_no_map[no_ps] == 40){n_channel = 576;}
  else if (psi_no_map[no_ps] == 41){n_channel = 288;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeeexex04_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeeexex04_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeeexex04_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeeexex04_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppeeexex04_ax_psp_240_gg_ememepepddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppeeexex04_ax_psp_240_gg_ememepepuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppeeexex04_ax_psp_240_gd_ememepepgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppeeexex04_ax_psp_240_gu_ememepepgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppeeexex04_ax_psp_240_gdx_ememepepgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppeeexex04_ax_psp_240_gux_ememepepgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppeeexex04_ax_psp_240_dd_ememepepdd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppeeexex04_ax_psp_240_du_ememepepdu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppeeexex04_ax_psp_240_ds_ememepepds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppeeexex04_ax_psp_240_dc_ememepepdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppeeexex04_ax_psp_240_ddx_ememepepgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppeeexex04_ax_psp_240_ddx_ememepepddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppeeexex04_ax_psp_240_ddx_ememepepuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppeeexex04_ax_psp_240_ddx_ememepepssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppeeexex04_ax_psp_240_ddx_ememepepccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppeeexex04_ax_psp_240_dux_ememepepdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppeeexex04_ax_psp_240_dsx_ememepepdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppeeexex04_ax_psp_240_dcx_ememepepdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppeeexex04_ax_psp_240_uu_ememepepuu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppeeexex04_ax_psp_240_uc_ememepepuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppeeexex04_ax_psp_240_udx_ememepepudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppeeexex04_ax_psp_240_uux_ememepepgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppeeexex04_ax_psp_240_uux_ememepepddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppeeexex04_ax_psp_240_uux_ememepepuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppeeexex04_ax_psp_240_uux_ememepepssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppeeexex04_ax_psp_240_uux_ememepepccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppeeexex04_ax_psp_240_usx_ememepepusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppeeexex04_ax_psp_240_ucx_ememepepucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppeeexex04_ax_psp_240_dxdx_ememepepdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppeeexex04_ax_psp_240_dxux_ememepepdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppeeexex04_ax_psp_240_dxsx_ememepepdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppeeexex04_ax_psp_240_dxcx_ememepepdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppeeexex04_ax_psp_240_uxux_ememepepuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppeeexex04_ax_psp_240_uxcx_ememepepuxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
