#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeex02/header/ppeex02.phasespace.h"
void ppeex02_ax_psp_220_uux_emepgg(int no_ps, phasespace_set & psi){
  static Logger logger("ppeex02_ax_psp_220_uux_emepgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(4);
  psi_needed_v_smin[no_ps].resize(4);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 16);
  int needed_v_smin_1[] = {  12,   13,   14,   15}; //   4
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   0,    1,    4,    5,   10,   11}; //   6
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 6);
  int needed_v_smin_3[] = {   2,    3,    6,    7,    8,    9}; //   6
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 6);

  psi_v_smax[no_ps].resize(6);
  psi_needed_v_smax[no_ps].resize(6);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   14,   15}; //  14
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 14);
  int needed_v_smax_1[] = {  12,   13}; //   2
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {  12,   13}; //   2
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 2);
  int needed_v_smax_3[] = {  14,   15}; //   2
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 2);
  int needed_v_smax_4[] = {   0,    1,    4,    5,   10,   11}; //   6
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 6);
  int needed_v_smax_5[] = {   2,    3,    6,    7,    8,    9}; //   6
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 6);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(6);
  psi_needed_g_p[no_ps].resize(6);
  int needed_g_p_0[] = {   0,    2,    4,    6,    8,   10,   14}; //   7
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 7);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   1,    3,    5,    7,    9,   11,   15}; //   7
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 7);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_2[] = {  12,   13}; //   2
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_3[] = {  12}; //   1
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 1);
  psi_container_IS_name.push_back("propagator_0_smin0_smax2");
  int needed_g_p_4[] = {  13}; //   1
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 1);
  psi_container_IS_name.push_back("propagator_23_smin0_smax2");
  int needed_g_p_5[] = {  14,   15}; //   2
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax3");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(2);
  psi_needed_g_f[no_ps].resize(2);
  int needed_g_f_0[] = {   0,    1,    4,    5,   10,   11}; //   6
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 6);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax4");
  int needed_g_f_1[] = {   2,    3,    6,    7,    8,    9}; //   6
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 6);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax5");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(12);
  psi_needed_g_t[no_ps].resize(12);
  int needed_g_t_0[] = {   0,    1}; //   2
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_28");
  int needed_g_t_1[] = {   0,    1}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_34__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_34__12_16");
  int needed_g_t_2[] = {   2,    3}; //   2
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_44");
  int needed_g_t_3[] = {   2,    3}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__12_32");
  int needed_g_t_4[] = {   4,    5,   10,   11}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_28");
  int needed_g_t_5[] = {   4,    5}; //   2
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__16_12");
  int needed_g_t_6[] = {   6,    7,    8,    9}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_44");
  int needed_g_t_7[] = {   6,    7}; //   2
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__32_12");
  int needed_g_t_8[] = {   8,    9}; //   2
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__12_32");
  int needed_g_t_9[] = {  10,   11}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__12_16");
  int needed_g_t_10[] = {  12,   13}; //   2
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_48");
  int needed_g_t_11[] = {  14,   15}; //   2
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_12");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(2);
  psi_needed_g_d[no_ps].resize(2);
  int needed_g_d_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 16);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {  12,   13,   14,   15}; //   4
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 4);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");

  psi_c_p[no_ps].resize(16);
  psi_c_f[no_ps].resize(16);
  psi_c_t[no_ps].resize(16);
  psi_c_d[no_ps].resize(16);

  int c_p_0[] = {  0}; //   1
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 1);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {  0}; //   1
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 1);

  int c_p_1[] = {  1}; //   1
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 1);
  int c_f_1[] = {  0}; //   1
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 1);
  int c_t_1[] = {  0,   1}; //   2
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 2);
  int c_d_1[] = {  0}; //   1
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 1);

  int c_p_2[] = {  0}; //   1
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 1);
  int c_f_2[] = {  1}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  2,   3}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  0}; //   1
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 1);

  int c_p_3[] = {  1}; //   1
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 1);
  int c_f_3[] = {  1}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  2,   3}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  0}; //   1
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 1);

  int c_p_4[] = {  0}; //   1
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 1);
  int c_f_4[] = {  0}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  4,   5}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  0}; //   1
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 1);

  int c_p_5[] = {  1}; //   1
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 1);
  int c_f_5[] = {  0}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = {  4,   5}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  0}; //   1
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 1);

  int c_p_6[] = {  0}; //   1
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 1);
  int c_f_6[] = {  1}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = {  6,   7}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  0}; //   1
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 1);

  int c_p_7[] = {  1}; //   1
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 1);
  int c_f_7[] = {  1}; //   1
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 1);
  int c_t_7[] = {  6,   7}; //   2
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 2);
  int c_d_7[] = {  0}; //   1
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 1);

  int c_p_8[] = {  0}; //   1
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 1);
  int c_f_8[] = {  1}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = {  6,   8}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = {  0}; //   1
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 1);

  int c_p_9[] = {  1}; //   1
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 1);
  int c_f_9[] = {  1}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = {  6,   8}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = {  0}; //   1
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 1);

  int c_p_10[] = {  0}; //   1
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 1);
  int c_f_10[] = {  0}; //   1
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 1);
  int c_t_10[] = {  4,   9}; //   2
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 2);
  int c_d_10[] = {  0}; //   1
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 1);

  int c_p_11[] = {  1}; //   1
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 1);
  int c_f_11[] = {  0}; //   1
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 1);
  int c_t_11[] = {  4,   9}; //   2
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 2);
  int c_d_11[] = {  0}; //   1
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 1);

  int c_p_12[] = {  2,   3}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = { 10}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  0,   1}; //   2
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 2);

  int c_p_13[] = {  2,   4}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = { 10}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  0,   1}; //   2
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 2);

  int c_p_14[] = {  0,   5}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = { 11}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  1,   0}; //   2
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 2);

  int c_p_15[] = {  1,   5}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = { 11}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  1,   0}; //   2
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
