#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexa03/header/ppeexa03.phasespace.h"
void ppeexa03_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppeexa03_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeexa03_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexa03_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 232;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 92;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 92;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 92;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 92;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 92;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 92;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 112;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 56;}
  else if (psi_no_map[no_ps] == 10){n_channel = 56;}
  else if (psi_no_map[no_ps] == 11){n_channel = 56;}
  else if (psi_no_map[no_ps] == 13){n_channel = 92;}
  else if (psi_no_map[no_ps] == 14){n_channel = 112;}
  else if (psi_no_map[no_ps] == 15){n_channel = 56;}
  else if (psi_no_map[no_ps] == 16){n_channel = 56;}
  else if (psi_no_map[no_ps] == 17){n_channel = 56;}
  else if (psi_no_map[no_ps] == 18){n_channel = 56;}
  else if (psi_no_map[no_ps] == 20){n_channel = 56;}
  else if (psi_no_map[no_ps] == 22){n_channel = 56;}
  else if (psi_no_map[no_ps] == 23){n_channel = 112;}
  else if (psi_no_map[no_ps] == 24){n_channel = 56;}
  else if (psi_no_map[no_ps] == 25){n_channel = 56;}
  else if (psi_no_map[no_ps] == 27){n_channel = 92;}
  else if (psi_no_map[no_ps] == 28){n_channel = 56;}
  else if (psi_no_map[no_ps] == 29){n_channel = 112;}
  else if (psi_no_map[no_ps] == 30){n_channel = 56;}
  else if (psi_no_map[no_ps] == 31){n_channel = 56;}
  else if (psi_no_map[no_ps] == 32){n_channel = 56;}
  else if (psi_no_map[no_ps] == 34){n_channel = 56;}
  else if (psi_no_map[no_ps] == 35){n_channel = 112;}
  else if (psi_no_map[no_ps] == 36){n_channel = 56;}
  else if (psi_no_map[no_ps] == 37){n_channel = 56;}
  else if (psi_no_map[no_ps] == 38){n_channel = 56;}
  else if (psi_no_map[no_ps] == 40){n_channel = 112;}
  else if (psi_no_map[no_ps] == 41){n_channel = 56;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexa03_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeexa03_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexa03_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexa03_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppeexa03_ax_psp_230_gg_emepaddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppeexa03_ax_psp_230_gg_emepauux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppeexa03_ax_psp_230_gd_emepagd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppeexa03_ax_psp_230_gu_emepagu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppeexa03_ax_psp_230_gdx_emepagdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppeexa03_ax_psp_230_gux_emepagux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppeexa03_ax_psp_230_dd_emepadd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppeexa03_ax_psp_230_du_emepadu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppeexa03_ax_psp_230_ds_emepads(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppeexa03_ax_psp_230_dc_emepadc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppeexa03_ax_psp_230_ddx_emepagg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppeexa03_ax_psp_230_ddx_emepaddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppeexa03_ax_psp_230_ddx_emepauux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppeexa03_ax_psp_230_ddx_emepassx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppeexa03_ax_psp_230_ddx_emepaccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppeexa03_ax_psp_230_dux_emepadux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppeexa03_ax_psp_230_dsx_emepadsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppeexa03_ax_psp_230_dcx_emepadcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppeexa03_ax_psp_230_uu_emepauu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppeexa03_ax_psp_230_uc_emepauc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppeexa03_ax_psp_230_udx_emepaudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppeexa03_ax_psp_230_uux_emepagg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppeexa03_ax_psp_230_uux_emepaddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppeexa03_ax_psp_230_uux_emepauux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppeexa03_ax_psp_230_uux_emepassx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppeexa03_ax_psp_230_uux_emepaccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppeexa03_ax_psp_230_usx_emepausx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppeexa03_ax_psp_230_ucx_emepaucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppeexa03_ax_psp_230_dxdx_emepadxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppeexa03_ax_psp_230_dxux_emepadxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppeexa03_ax_psp_230_dxsx_emepadxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppeexa03_ax_psp_230_dxcx_emepadxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppeexa03_ax_psp_230_uxux_emepauxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppeexa03_ax_psp_230_uxcx_emepauxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
