#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexnenex04/header/ppeexnenex04.phasespace.h"
void ppeexnenex04_ax_psp_140_ddx_emepvevexg(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexnenex04_ax_psp_140_ddx_emepvevexg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(21);
  psi_needed_v_smin[no_ps].resize(21);
  int needed_v_smin_0[] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   31,   32,   33,   34,   36,   37,   38,   39,   41,   42}; //  20
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 20);
  int needed_v_smin_1[] = {   0,    1,   14,   15}; //   4
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   0,    1,    2,    3,   14,   15,   16,   17}; //   8
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 8);
  int needed_v_smin_3[] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   40}; //  13
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 13);
  int needed_v_smin_4[] = {   2,    3,   16,   17}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {   4,   18}; //   2
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 2);
  int needed_v_smin_6[] = {   4,    6,   18,   20}; //   4
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 4);
  int needed_v_smin_7[] = {   5,    6,   19,   20,   28,   29,   31,   32,   33,   34,   36,   37,   38,   39,   41,   42}; //  16
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 16);
  int needed_v_smin_8[] = {   5,   19}; //   2
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   5,   11,   19,   25}; //   4
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 4);
  int needed_v_smin_10[] = {   6,   20}; //   2
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 2);
  int needed_v_smin_11[] = {   7,    8,   21,   22}; //   4
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 4);
  int needed_v_smin_12[] = {   7,    8,    9,   10,   21,   22,   23,   24}; //   8
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 8);
  int needed_v_smin_13[] = {   9,   10,   11,   12,   13,   23,   24,   25,   26,   27,   30,   35,   40}; //  13
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 13);
  int needed_v_smin_14[] = {   9,   10,   23,   24}; //   4
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 4);
  int needed_v_smin_15[] = {  11,   25}; //   2
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 2);
  int needed_v_smin_16[] = {  12,   13,   26,   27,   30,   40}; //   6
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 6);
  int needed_v_smin_17[] = {  28,   29,   31,   32,   38,   39,   41,   42}; //   8
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 8);
  int needed_v_smin_18[] = {  33,   34}; //   2
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 2);
  int needed_v_smin_19[] = {  35}; //   1
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 1);
  int needed_v_smin_20[] = {  36,   37}; //   2
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 2);

  psi_v_smax[no_ps].resize(15);
  psi_needed_v_smax[no_ps].resize(15);
  int needed_v_smax_0[] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   33,   34,   38,   39}; //  14
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 14);
  int needed_v_smax_1[] = {   0,    1,    2,    3,   14,   15,   16,   17}; //   8
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 8);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   38,   39,   40,   41,   42}; //  38
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 38);
  int needed_v_smax_3[] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   40}; //  13
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 13);
  int needed_v_smax_4[] = {   4,    6,   18,   20}; //   4
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 4);
  int needed_v_smax_5[] = {   5,    6,   19,   20,   31,   32,   36,   37,   41,   42}; //  10
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 10);
  int needed_v_smax_6[] = {   5,   11,   19,   25}; //   4
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 4);
  int needed_v_smax_7[] = {   7,    8,    9,   10,   21,   22,   23,   24}; //   8
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 8);
  int needed_v_smax_8[] = {   9,   10,   11,   23,   24,   25}; //   6
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 6);
  int needed_v_smax_9[] = {  12,   13,   26,   27,   30,   35,   40}; //   7
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 7);
  int needed_v_smax_10[] = {  28,   29,   33,   34,   38,   39}; //   6
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 6);
  int needed_v_smax_11[] = {  31,   32,   36,   37,   41,   42}; //   6
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 6);
  int needed_v_smax_12[] = {  33,   34}; //   2
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 2);
  int needed_v_smax_13[] = {  35}; //   1
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 1);
  int needed_v_smax_14[] = {  36,   37}; //   2
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(25);
  psi_needed_g_p[no_ps].resize(25);
  int needed_g_p_0[] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   33,   34,   38,   39}; //  14
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 14);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_1[] = {   0,    1,   14,   15}; //   4
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 4);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    2,   14,   16}; //   4
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 4);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   1,    3,   15,   17}; //   4
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 4);
  psi_container_IS_name.push_back("propagator_23_smin2_smax2");
  int needed_g_p_4[] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   40}; //  13
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 13);
  psi_container_IS_name.push_back("propagator_24_smin3_smax3");
  int needed_g_p_5[] = {   2,    3,   16,   17}; //   4
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 4);
  psi_container_IS_name.push_back("propagator_0_smin4_smax1");
  int needed_g_p_6[] = {   4,   18}; //   2
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_7[] = {   4,    6,   18,   20}; //   4
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 4);
  psi_container_IS_name.push_back("propagator_23_smin6_smax2");
  int needed_g_p_8[] = {   5,    6,   19,   20,   32,   37,   42}; //   7
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 7);
  psi_container_IS_name.push_back("propagator_23_smin7_smax5");
  int needed_g_p_9[] = {   5,   19}; //   2
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax6");
  int needed_g_p_10[] = {   5,   11,   19,   25}; //   4
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 4);
  psi_container_IS_name.push_back("propagator_23_smin9_smax2");
  int needed_g_p_11[] = {   6,   20}; //   2
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 2);
  psi_container_IS_name.push_back("propagator_0_smin10_smax4");
  int needed_g_p_12[] = {   7,    8,   21,   22}; //   4
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 4);
  psi_container_IS_name.push_back("propagator_0_smin11_smax7");
  int needed_g_p_13[] = {   7,    9,   21,   23}; //   4
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 4);
  psi_container_IS_name.push_back("propagator_0_smin12_smax2");
  int needed_g_p_14[] = {   8,   10,   22,   24}; //   4
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 4);
  psi_container_IS_name.push_back("propagator_23_smin12_smax2");
  int needed_g_p_15[] = {   9,   10,   11,   23,   24,   25}; //   6
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 6);
  psi_container_IS_name.push_back("propagator_24_smin13_smax8");
  int needed_g_p_16[] = {   9,   10,   23,   24}; //   4
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 4);
  psi_container_IS_name.push_back("propagator_0_smin14_smax7");
  int needed_g_p_17[] = {  11,   25}; //   2
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 2);
  psi_container_IS_name.push_back("propagator_0_smin15_smax6");
  int needed_g_p_18[] = {  12,   13,   26,   27,   30,   35,   40}; //   7
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 7);
  psi_container_IS_name.push_back("propagator_24_smin13_smax9");
  int needed_g_p_19[] = {  12,   26}; //   2
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 2);
  psi_container_IS_name.push_back("propagator_0_smin16_smax2");
  int needed_g_p_20[] = {  13,   27}; //   2
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 2);
  psi_container_IS_name.push_back("propagator_23_smin16_smax2");
  int needed_g_p_21[] = {  28,   33,   38}; //   3
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 3);
  psi_container_IS_name.push_back("propagator_0_smin7_smax10");
  int needed_g_p_22[] = {  29,   34,   39}; //   3
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 3);
  psi_container_IS_name.push_back("propagator_23_smin7_smax10");
  int needed_g_p_23[] = {  31,   36,   41}; //   3
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 3);
  psi_container_IS_name.push_back("propagator_0_smin7_smax5");
  int needed_g_p_24[] = {  31,   32,   36,   37,   41,   42}; //   6
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 6);
  psi_container_IS_name.push_back("propagator_23_smin0_smax11");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(5);
  psi_needed_g_f[no_ps].resize(5);
  int needed_g_f_0[] = {  28,   29,   31,   32,   38,   39,   41,   42}; //   8
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax2");
  int needed_g_f_1[] = {  30,   40}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax2");
  int needed_g_f_2[] = {  33,   34}; //   2
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin18_smax12");
  int needed_g_f_3[] = {  35}; //   1
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin19_smax13");
  int needed_g_f_4[] = {  36,   37}; //   2
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin20_smax14");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(14);
  psi_needed_g_t[no_ps].resize(14);
  int needed_g_t_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   28,   29,   30,   31,   32}; //  19
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 19);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_60");
  int needed_g_t_1[] = {  14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   38,   39,   40,   41,   42}; //  19
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 19);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_60");
  int needed_g_t_2[] = {  28,   29}; //   2
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__12_48");
  int needed_g_t_3[] = {  30}; //   1
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__36_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__36_24");
  int needed_g_t_4[] = {  31,   32}; //   2
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__48_12");
  int needed_g_t_5[] = {  33,   34}; //   2
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_112");
  int needed_g_t_6[] = {  33,   34}; //   2
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__48_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__48_64");
  int needed_g_t_7[] = {  35}; //   1
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__36_88");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__36_88");
  int needed_g_t_8[] = {  35}; //   1
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_37__24_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_37__24_64");
  int needed_g_t_9[] = {  36,   37}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_76");
  int needed_g_t_10[] = {  36,   37}; //   2
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__12_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__12_64");
  int needed_g_t_11[] = {  38,   39}; //   2
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__48_12");
  int needed_g_t_12[] = {  40}; //   1
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__24_36");
  int needed_g_t_13[] = {  41,   42}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__12_48");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(17);
  psi_needed_g_d[no_ps].resize(17);
  int needed_g_d_0[] = {   0,    1,    2,    3,   14,   15,   16,   17}; //   8
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_1[] = {   0,    1,   14,   15}; //   4
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 4);
  psi_container_IS_name.push_back("costheta_of_decay_56__8_48");
  psi_container_IS_name.push_back("phi_of_decay_56__8_48");
  int needed_g_d_2[] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   31,   32,   33,   34,   36,   37,   38,   39,   41,   42}; //  20
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 20);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_3[] = {   2,    3,   16,   17}; //   4
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 4);
  psi_container_IS_name.push_back("costheta_of_decay_56__32_24");
  psi_container_IS_name.push_back("phi_of_decay_56__32_24");
  int needed_g_d_4[] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   30,   35,   40}; //  13
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 13);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_5[] = {   4,    6,   18,   20}; //   4
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_6[] = {   4,   18}; //   2
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_7[] = {   5,   11,   19,   25}; //   4
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_8[] = {   5,   19}; //   2
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_9[] = {   5,    6,   19,   20,   28,   29,   31,   32,   33,   34,   36,   37,   38,   39,   41,   42}; //  16
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 16);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_10[] = {   6,   20}; //   2
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_11[] = {   7,    8,    9,   10,   21,   22,   23,   24}; //   8
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_12[] = {   7,    8,   21,   22}; //   4
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 4);
  psi_container_IS_name.push_back("costheta_of_decay_52__4_48");
  psi_container_IS_name.push_back("phi_of_decay_52__4_48");
  int needed_g_d_13[] = {   9,   10,   23,   24}; //   4
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 4);
  psi_container_IS_name.push_back("costheta_of_decay_52__16_36");
  psi_container_IS_name.push_back("phi_of_decay_52__16_36");
  int needed_g_d_14[] = {   9,   10,   11,   12,   13,   23,   24,   25,   26,   27,   30,   35,   40}; //  13
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 13);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");
  int needed_g_d_15[] = {  11,   25}; //   2
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__8_36");
  psi_container_IS_name.push_back("phi_of_decay_44__8_36");
  int needed_g_d_16[] = {  12,   13,   26,   27}; //   4
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__36_24");
  psi_container_IS_name.push_back("phi_of_decay_60__36_24");

  psi_c_p[no_ps].resize(43);
  psi_c_f[no_ps].resize(43);
  psi_c_t[no_ps].resize(43);
  psi_c_d[no_ps].resize(43);

  int c_p_0[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 3);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {  0}; //   1
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 1);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {  0}; //   1
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 1);
  int c_d_1[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  4,   5,   2}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {  0}; //   1
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 1);
  int c_d_2[] = {  0,   3,   4}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  4,   5,   3}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {  0}; //   1
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 1);
  int c_d_3[] = {  0,   3,   4}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  4,   6,   7}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {  0}; //   1
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 1);
  int c_d_4[] = {  5,   6,   4}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  8,   9,  10}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {  0}; //   1
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 1);
  int c_d_5[] = {  7,   8,   9}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  8,  11,   7}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  0}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  5,  10,   9}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  0,  12,  13}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  0}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = { 11,  12,   2}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  0,  12,  14}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  0}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = { 11,  12,   2}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = { 15,  16,  13}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  0}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = { 11,  13,  14}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = { 15,  16,  14}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  0}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = { 11,  13,  14}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = { 15,  17,  10}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  0}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  4,  18,  19}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  0}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = { 16,  14,   4}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  4,  18,  20}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = { 16,  14,   4}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  1}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  1}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  4,   5,   2}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  1}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = {  0,   3,   4}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  4,   5,   3}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  1}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = {  0,   3,   4}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  4,   6,   7}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {  1}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = {  5,   6,   4}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = {  8,   9,  10}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {  1}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = {  7,   8,   9}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = {  8,  11,   7}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {  1}; //   1
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 1);
  int c_d_20[] = {  5,  10,   9}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = {  0,  12,  13}; //   3
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 3);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {  1}; //   1
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 1);
  int c_d_21[] = { 11,  12,   2}; //   3
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 3);

  int c_p_22[] = {  0,  12,  14}; //   3
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 3);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {  1}; //   1
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 1);
  int c_d_22[] = { 11,  12,   2}; //   3
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 3);

  int c_p_23[] = { 15,  16,  13}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {  1}; //   1
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 1);
  int c_d_23[] = { 11,  13,  14}; //   3
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 3);

  int c_p_24[] = { 15,  16,  14}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  1}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = { 11,  13,  14}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = { 15,  17,  10}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  1}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 3);

  int c_p_26[] = {  4,  18,  19}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  1}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = { 16,  14,   4}; //   3
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 3);

  int c_p_27[] = {  4,  18,  20}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  1}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = { 16,  14,   4}; //   3
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 3);

  int c_p_28[] = {  0,  21}; //   2
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 2);
  int c_f_28[] = {  0}; //   1
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 1);
  int c_t_28[] = {  0,   2}; //   2
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 2);
  int c_d_28[] = {  9,   2}; //   2
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 2);

  int c_p_29[] = {  0,  22}; //   2
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 2);
  int c_f_29[] = {  0}; //   1
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 1);
  int c_t_29[] = {  0,   2}; //   2
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 2);
  int c_d_29[] = {  9,   2}; //   2
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 2);

  int c_p_30[] = {  4,  18}; //   2
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 2);
  int c_f_30[] = {  1}; //   1
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 1);
  int c_t_30[] = {  0,   3}; //   2
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 2);
  int c_d_30[] = { 14,   4}; //   2
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 2);

  int c_p_31[] = { 23,  24}; //   2
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 2);
  int c_f_31[] = {  0}; //   1
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 1);
  int c_t_31[] = {  0,   4}; //   2
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 2);
  int c_d_31[] = {  2,   9}; //   2
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 2);

  int c_p_32[] = {  8,  24}; //   2
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 2);
  int c_f_32[] = {  0}; //   1
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 1);
  int c_t_32[] = {  0,   4}; //   2
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 2);
  int c_d_32[] = {  2,   9}; //   2
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 2);

  int c_p_33[] = {  0,  21}; //   2
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 2);
  int c_f_33[] = {  2}; //   1
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 1);
  int c_t_33[] = {  5,   6}; //   2
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 2);
  int c_d_33[] = {  9,   2}; //   2
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 2);

  int c_p_34[] = {  0,  22}; //   2
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 2);
  int c_f_34[] = {  2}; //   1
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 1);
  int c_t_34[] = {  5,   6}; //   2
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 2);
  int c_d_34[] = {  9,   2}; //   2
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 2);

  int c_p_35[] = {  4,  18}; //   2
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 2);
  int c_f_35[] = {  3}; //   1
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 1);
  int c_t_35[] = {  7,   8}; //   2
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 2);
  int c_d_35[] = { 14,   4}; //   2
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 2);

  int c_p_36[] = { 23,  24}; //   2
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 2);
  int c_f_36[] = {  4}; //   1
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 1);
  int c_t_36[] = {  9,  10}; //   2
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 2);
  int c_d_36[] = {  2,   9}; //   2
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 2);

  int c_p_37[] = {  8,  24}; //   2
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 2);
  int c_f_37[] = {  4}; //   1
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 1);
  int c_t_37[] = {  9,  10}; //   2
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 2);
  int c_d_37[] = {  2,   9}; //   2
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 2);

  int c_p_38[] = {  0,  21}; //   2
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 2);
  int c_f_38[] = {  0}; //   1
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 1);
  int c_t_38[] = {  1,  11}; //   2
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 2);
  int c_d_38[] = {  9,   2}; //   2
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 2);

  int c_p_39[] = {  0,  22}; //   2
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 2);
  int c_f_39[] = {  0}; //   1
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 1);
  int c_t_39[] = {  1,  11}; //   2
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 2);
  int c_d_39[] = {  9,   2}; //   2
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 2);

  int c_p_40[] = {  4,  18}; //   2
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 2);
  int c_f_40[] = {  1}; //   1
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 1);
  int c_t_40[] = {  1,  12}; //   2
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 2);
  int c_d_40[] = { 14,   4}; //   2
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 2);

  int c_p_41[] = { 23,  24}; //   2
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 2);
  int c_f_41[] = {  0}; //   1
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 1);
  int c_t_41[] = {  1,  13}; //   2
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 2);
  int c_d_41[] = {  2,   9}; //   2
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 2);

  int c_p_42[] = {  8,  24}; //   2
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 2);
  int c_f_42[] = {  0}; //   1
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 1);
  int c_t_42[] = {  1,  13}; //   2
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 2);
  int c_d_42[] = {  2,   9}; //   2
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
