#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemexnmx04/header/ppemexnmx04.phasespace.h"
void ppemexnmx04_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppemexnmx04_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppemexnmx04_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppemexnmx04_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 262;}
  else if (psi_no_map[no_ps] ==  1){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 64;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 64;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 32;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 32;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 64;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 32;}
  else if (psi_no_map[no_ps] == 10){n_channel = 108;}
  else if (psi_no_map[no_ps] == 11){n_channel = 64;}
  else if (psi_no_map[no_ps] == 12){n_channel = 64;}
  else if (psi_no_map[no_ps] == 13){n_channel = 32;}
  else if (psi_no_map[no_ps] == 14){n_channel = 32;}
  else if (psi_no_map[no_ps] == 15){n_channel = 32;}
  else if (psi_no_map[no_ps] == 16){n_channel = 32;}
  else if (psi_no_map[no_ps] == 17){n_channel = 32;}
  else if (psi_no_map[no_ps] == 18){n_channel = 64;}
  else if (psi_no_map[no_ps] == 19){n_channel = 32;}
  else if (psi_no_map[no_ps] == 20){n_channel = 32;}
  else if (psi_no_map[no_ps] == 21){n_channel = 64;}
  else if (psi_no_map[no_ps] == 22){n_channel = 32;}
  else if (psi_no_map[no_ps] == 23){n_channel = 64;}
  else if (psi_no_map[no_ps] == 24){n_channel = 32;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemexnmx04_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppemexnmx04_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 21){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemexnmx04_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppemexnmx04_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){ppemexnmx04_ax_psp_240_gg_emmumepvmxudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  2){ppemexnmx04_ax_psp_240_gd_emmumepvmxgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppemexnmx04_ax_psp_240_gux_emmumepvmxgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppemexnmx04_ax_psp_240_dd_emmumepvmxdu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppemexnmx04_ax_psp_240_du_emmumepvmxuu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppemexnmx04_ax_psp_240_ds_emmumepvmxdc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppemexnmx04_ax_psp_240_dc_emmumepvmxuc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppemexnmx04_ax_psp_240_ddx_emmumepvmxudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppemexnmx04_ax_psp_240_ddx_emmumepvmxcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppemexnmx04_ax_psp_240_dux_emmumepvmxgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppemexnmx04_ax_psp_240_dux_emmumepvmxddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppemexnmx04_ax_psp_240_dux_emmumepvmxuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppemexnmx04_ax_psp_240_dux_emmumepvmxssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppemexnmx04_ax_psp_240_dux_emmumepvmxccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppemexnmx04_ax_psp_240_dsx_emmumepvmxusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppemexnmx04_ax_psp_240_dcx_emmumepvmxdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppemexnmx04_ax_psp_240_dcx_emmumepvmxucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppemexnmx04_ax_psp_240_uux_emmumepvmxudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 19){ppemexnmx04_ax_psp_240_uux_emmumepvmxcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppemexnmx04_ax_psp_240_ucx_emmumepvmxusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 21){ppemexnmx04_ax_psp_240_dxux_emmumepvmxdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppemexnmx04_ax_psp_240_dxcx_emmumepvmxdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppemexnmx04_ax_psp_240_uxux_emmumepvmxdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppemexnmx04_ax_psp_240_uxcx_emmumepvmxdxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
