#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../pph21/header/pph21.phasespace.h"
void pph21_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("pph21_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int pph21_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("pph21_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 15;}
  else if (psi_no_map[no_ps] ==  1){n_channel = 15;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 7;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 7;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 7;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 7;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 7;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 7;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 1;}
  else if (psi_no_map[no_ps] == 10){n_channel = 1;}
  else if (psi_no_map[no_ps] == 11){n_channel = 1;}
  else if (psi_no_map[no_ps] == 13){n_channel = 7;}
  else if (psi_no_map[no_ps] == 14){n_channel = 2;}
  else if (psi_no_map[no_ps] == 15){n_channel = 1;}
  else if (psi_no_map[no_ps] == 16){n_channel = 1;}
  else if (psi_no_map[no_ps] == 17){n_channel = 1;}
  else if (psi_no_map[no_ps] == 18){n_channel = 1;}
  else if (psi_no_map[no_ps] == 20){n_channel = 1;}
  else if (psi_no_map[no_ps] == 22){n_channel = 1;}
  else if (psi_no_map[no_ps] == 23){n_channel = 2;}
  else if (psi_no_map[no_ps] == 24){n_channel = 1;}
  else if (psi_no_map[no_ps] == 25){n_channel = 1;}
  else if (psi_no_map[no_ps] == 27){n_channel = 7;}
  else if (psi_no_map[no_ps] == 28){n_channel = 1;}
  else if (psi_no_map[no_ps] == 29){n_channel = 2;}
  else if (psi_no_map[no_ps] == 30){n_channel = 1;}
  else if (psi_no_map[no_ps] == 31){n_channel = 1;}
  else if (psi_no_map[no_ps] == 32){n_channel = 1;}
  else if (psi_no_map[no_ps] == 34){n_channel = 1;}
  else if (psi_no_map[no_ps] == 35){n_channel = 2;}
  else if (psi_no_map[no_ps] == 36){n_channel = 1;}
  else if (psi_no_map[no_ps] == 37){n_channel = 1;}
  else if (psi_no_map[no_ps] == 38){n_channel = 1;}
  else if (psi_no_map[no_ps] == 40){n_channel = 2;}
  else if (psi_no_map[no_ps] == 41){n_channel = 1;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void pph21_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("pph21_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void pph21_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("pph21_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){pph21_ax_psp_410_gg_hgg(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  2){pph21_ax_psp_410_gg_hddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){pph21_ax_psp_410_gg_huux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){pph21_ax_psp_410_gd_hgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){pph21_ax_psp_410_gu_hgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){pph21_ax_psp_410_gdx_hgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){pph21_ax_psp_410_gux_hgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){pph21_ax_psp_410_dd_hdd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){pph21_ax_psp_410_du_hdu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){pph21_ax_psp_410_ds_hds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){pph21_ax_psp_410_dc_hdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){pph21_ax_psp_410_ddx_hgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){pph21_ax_psp_410_ddx_hddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){pph21_ax_psp_410_ddx_huux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){pph21_ax_psp_410_ddx_hssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){pph21_ax_psp_410_ddx_hccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){pph21_ax_psp_410_dux_hdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){pph21_ax_psp_410_dsx_hdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){pph21_ax_psp_410_dcx_hdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){pph21_ax_psp_410_uu_huu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){pph21_ax_psp_410_uc_huc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){pph21_ax_psp_410_udx_hudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){pph21_ax_psp_410_uux_hgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){pph21_ax_psp_410_uux_hddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){pph21_ax_psp_410_uux_huux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){pph21_ax_psp_410_uux_hssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){pph21_ax_psp_410_uux_hccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){pph21_ax_psp_410_usx_husx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){pph21_ax_psp_410_ucx_hucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){pph21_ax_psp_410_dxdx_hdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){pph21_ax_psp_410_dxux_hdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){pph21_ax_psp_410_dxsx_hdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){pph21_ax_psp_410_dxcx_hdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){pph21_ax_psp_410_uxux_huxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){pph21_ax_psp_410_uxcx_huxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
