#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppnenex02/header/ppnenex02.phasespace.h"
void ppnenex02_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppnenex02_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppnenex02_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenex02_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 15;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 4;}
  else if (psi_no_map[no_ps] == 10){n_channel = 4;}
  else if (psi_no_map[no_ps] == 11){n_channel = 4;}
  else if (psi_no_map[no_ps] == 13){n_channel = 8;}
  else if (psi_no_map[no_ps] == 14){n_channel = 8;}
  else if (psi_no_map[no_ps] == 15){n_channel = 4;}
  else if (psi_no_map[no_ps] == 16){n_channel = 4;}
  else if (psi_no_map[no_ps] == 17){n_channel = 4;}
  else if (psi_no_map[no_ps] == 18){n_channel = 4;}
  else if (psi_no_map[no_ps] == 20){n_channel = 4;}
  else if (psi_no_map[no_ps] == 22){n_channel = 4;}
  else if (psi_no_map[no_ps] == 23){n_channel = 8;}
  else if (psi_no_map[no_ps] == 24){n_channel = 4;}
  else if (psi_no_map[no_ps] == 25){n_channel = 4;}
  else if (psi_no_map[no_ps] == 27){n_channel = 8;}
  else if (psi_no_map[no_ps] == 28){n_channel = 4;}
  else if (psi_no_map[no_ps] == 29){n_channel = 8;}
  else if (psi_no_map[no_ps] == 30){n_channel = 4;}
  else if (psi_no_map[no_ps] == 31){n_channel = 4;}
  else if (psi_no_map[no_ps] == 32){n_channel = 4;}
  else if (psi_no_map[no_ps] == 34){n_channel = 4;}
  else if (psi_no_map[no_ps] == 35){n_channel = 8;}
  else if (psi_no_map[no_ps] == 36){n_channel = 4;}
  else if (psi_no_map[no_ps] == 37){n_channel = 4;}
  else if (psi_no_map[no_ps] == 38){n_channel = 4;}
  else if (psi_no_map[no_ps] == 40){n_channel = 8;}
  else if (psi_no_map[no_ps] == 41){n_channel = 4;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppnenex02_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppnenex02_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppnenex02_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenex02_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppnenex02_ax_psp_220_gg_vevexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppnenex02_ax_psp_220_gg_vevexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppnenex02_ax_psp_220_gd_vevexgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppnenex02_ax_psp_220_gu_vevexgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppnenex02_ax_psp_220_gdx_vevexgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppnenex02_ax_psp_220_gux_vevexgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppnenex02_ax_psp_220_dd_vevexdd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppnenex02_ax_psp_220_du_vevexdu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppnenex02_ax_psp_220_ds_vevexds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppnenex02_ax_psp_220_dc_vevexdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppnenex02_ax_psp_220_ddx_vevexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppnenex02_ax_psp_220_ddx_vevexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppnenex02_ax_psp_220_ddx_vevexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppnenex02_ax_psp_220_ddx_vevexssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppnenex02_ax_psp_220_ddx_vevexccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppnenex02_ax_psp_220_dux_vevexdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppnenex02_ax_psp_220_dsx_vevexdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppnenex02_ax_psp_220_dcx_vevexdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppnenex02_ax_psp_220_uu_vevexuu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppnenex02_ax_psp_220_uc_vevexuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppnenex02_ax_psp_220_udx_vevexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppnenex02_ax_psp_220_uux_vevexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppnenex02_ax_psp_220_uux_vevexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppnenex02_ax_psp_220_uux_vevexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppnenex02_ax_psp_220_uux_vevexssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppnenex02_ax_psp_220_uux_vevexccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppnenex02_ax_psp_220_usx_vevexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppnenex02_ax_psp_220_ucx_vevexucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppnenex02_ax_psp_220_dxdx_vevexdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppnenex02_ax_psp_220_dxux_vevexdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppnenex02_ax_psp_220_dxsx_vevexdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppnenex02_ax_psp_220_dxcx_vevexdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppnenex02_ax_psp_220_uxux_vevexuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppnenex02_ax_psp_220_uxcx_vevexuxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
