#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppnenexa03/header/ppnenexa03.phasespace.h"
void ppnenexa03_ax_psp_230_uu_vevexauu(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenexa03_ax_psp_230_uu_vevexauu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(15);
  psi_needed_v_smin[no_ps].resize(15);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  40
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 40);
  int needed_v_smin_1[] = {   4,    6,   12,   14,   17,   22,   30,   36,   11,   20,   34}; //  11
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 11);
  int needed_v_smin_2[] = {   5,    7,   13,   15,   16,   23,   31,   37,   10,   21,   35}; //  11
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 11);
  int needed_v_smin_3[] = {   6,   17,   12,   20}; //   4
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 4);
  int needed_v_smin_4[] = {   7,   16,   13,   21}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {   8,   18,   28,   30,   32,   34,   36,   38,    0,   27}; //  10
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 10);
  int needed_v_smin_6[] = {   8,   18,    0,   27,   28,   38}; //   6
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 6);
  int needed_v_smin_7[] = {   9,   19,   29,   31,   33,   35,   37,   39,    1,   26}; //  10
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 10);
  int needed_v_smin_8[] = {   9,   19,    1,   26,   29,   39}; //   6
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 6);
  int needed_v_smin_9[] = {   2,    3,   24,   25}; //   4
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 4);
  int needed_v_smin_10[] = {   2,    3,   24,   25}; //   4
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 4);
  int needed_v_smin_11[] = {   4,   11,   14,   22}; //   4
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 4);
  int needed_v_smin_12[] = {   5,   10,   15,   23}; //   4
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 4);
  int needed_v_smin_13[] = {  32}; //   1
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 1);
  int needed_v_smin_14[] = {  33}; //   1
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 1);

  psi_v_smax[no_ps].resize(18);
  psi_needed_v_smax[no_ps].resize(18);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   34,   35,   38,   39}; //  30
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 30);
  int needed_v_smax_1[] = {   4,    6,   12,   14,   17,   22,   30,   11,   20}; //   9
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 9);
  int needed_v_smax_2[] = {   5,    7,   13,   15,   16,   23,   31,   10,   21}; //   9
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 9);
  int needed_v_smax_3[] = {   6,    9,   17,   19,    1,   12,   20,   26,   29,   39}; //  10
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 10);
  int needed_v_smax_4[] = {   7,    8,   16,   18,    0,   13,   21,   27,   28,   38}; //  10
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 10);
  int needed_v_smax_5[] = {   8,   18,   28,   32,   36}; //   5
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 5);
  int needed_v_smax_6[] = {   8,   18,   28,   32,   36}; //   5
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 5);
  int needed_v_smax_7[] = {   9,   19,   29,   33,   37}; //   5
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 5);
  int needed_v_smax_8[] = {   9,   19,   29,   33,   37}; //   5
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 5);
  int needed_v_smax_9[] = {  30}; //   1
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 1);
  int needed_v_smax_10[] = {  31}; //   1
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 1);
  int needed_v_smax_11[] = {  34,   38,    0,   27}; //   4
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 4);
  int needed_v_smax_12[] = {  35,   39,    1,   26}; //   4
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 4);
  int needed_v_smax_13[] = {  36,   34}; //   2
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 2);
  int needed_v_smax_14[] = {  37,   35}; //   2
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 2);
  int needed_v_smax_15[] = {   2,    3,   24,   25}; //   4
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 4);
  int needed_v_smax_16[] = {   2,    3,    4,    5,   10,   11,   14,   15,   22,   23,   24,   25}; //  12
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 12);
  int needed_v_smax_17[] = {  32,   33}; //   2
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(17);
  psi_needed_g_p[no_ps].resize(17);
  int needed_g_p_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   34,   35,   38,   39}; //  30
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 30);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_1[] = {   4,    6,   12,   14,   17,   22,   30}; //   7
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 7);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   5,    7,   13,   15,   16,   23,   31}; //   7
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 7);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   6,   17}; //   2
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {   7,   16}; //   2
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_5[] = {   8,   18,   28,   32,   36}; //   5
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 5);
  psi_container_IS_name.push_back("propagator_0_smin5_smax5");
  int needed_g_p_6[] = {   8,   18,   28,   32,   36}; //   5
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 5);
  psi_container_IS_name.push_back("propagator_23_smin0_smax6");
  int needed_g_p_7[] = {   8,   18}; //   2
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 2);
  psi_container_IS_name.push_back("propagator_0_smin6_smax4");
  int needed_g_p_8[] = {   9,   19,   29,   33,   37}; //   5
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 5);
  psi_container_IS_name.push_back("propagator_0_smin7_smax7");
  int needed_g_p_9[] = {   9,   19,   29,   33,   37}; //   5
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 5);
  psi_container_IS_name.push_back("propagator_23_smin0_smax8");
  int needed_g_p_10[] = {   9,   19}; //   2
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax3");
  int needed_g_p_11[] = {  30}; //   1
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 1);
  psi_container_IS_name.push_back("propagator_0_smin5_smax9");
  int needed_g_p_12[] = {  31}; //   1
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 1);
  psi_container_IS_name.push_back("propagator_0_smin7_smax10");
  int needed_g_p_13[] = {  34,   38}; //   2
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax11");
  int needed_g_p_14[] = {  35,   39}; //   2
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 2);
  psi_container_IS_name.push_back("propagator_0_smin7_smax12");
  int needed_g_p_15[] = {  36}; //   1
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 1);
  psi_container_IS_name.push_back("propagator_0_smin1_smax13");
  int needed_g_p_16[] = {  37}; //   1
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 1);
  psi_container_IS_name.push_back("propagator_0_smin2_smax14");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(16);
  psi_needed_g_f[no_ps].resize(16);
  int needed_g_f_0[] = {   0,   27}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax11");
  int needed_g_f_1[] = {   0,   27,   28,   38}; //   4
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax4");
  int needed_g_f_2[] = {   1,   26}; //   2
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax12");
  int needed_g_f_3[] = {   1,   26,   29,   39}; //   4
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax3");
  int needed_g_f_4[] = {   2,    3,   24,   25}; //   4
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax15");
  int needed_g_f_5[] = {   2,    3,   24,   25}; //   4
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax16");
  int needed_g_f_6[] = {   4,   11,   14,   22}; //   4
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax16");
  int needed_g_f_7[] = {   5,   10,   15,   23}; //   4
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax16");
  int needed_g_f_8[] = {  10,   21}; //   2
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax2");
  int needed_g_f_9[] = {  11,   20}; //   2
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax1");
  int needed_g_f_10[] = {  12,   20}; //   2
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax3");
  int needed_g_f_11[] = {  13,   21}; //   2
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax4");
  int needed_g_f_12[] = {  32}; //   1
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax17");
  int needed_g_f_13[] = {  33}; //   1
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin14_smax17");
  int needed_g_f_14[] = {  34}; //   1
  psi_needed_g_f[no_ps][14] = get_vector_from_array_int(needed_g_f_14, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax13");
  int needed_g_f_15[] = {  35}; //   1
  psi_needed_g_f[no_ps][15] = get_vector_from_array_int(needed_g_f_15, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax14");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(41);
  psi_needed_g_t[no_ps].resize(41);
  int needed_g_t_0[] = {   0,    7,    8,   28}; //   4
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_60");
  int needed_g_t_1[] = {   0,   28}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__12_48");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_13__32_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_13__32_16");
  int needed_g_t_3[] = {   1,    6,    9,   29}; //   4
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_92");
  int needed_g_t_4[] = {   1,   29}; //   2
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_34__12_80");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_34__12_80");
  int needed_g_t_5[] = {   1}; //   1
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__34_13__64_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__34_13__64_16");
  int needed_g_t_6[] = {   2,    3,    4,    5}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_108");
  int needed_g_t_7[] = {   2,    3}; //   2
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__12_96");
  int needed_g_t_8[] = {   2}; //   1
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_13__64_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_13__64_32");
  int needed_g_t_9[] = {   3}; //   1
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_13__32_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_13__32_64");
  int needed_g_t_10[] = {   4}; //   1
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__18_1__32_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__18_1__32_76");
  int needed_g_t_11[] = {   5}; //   1
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__18_1__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__18_1__64_44");
  int needed_g_t_12[] = {  10,   11,   14,   15,   22,   23,   24,   25}; //   8
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_108");
  int needed_g_t_13[] = {  10,   15}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__64_44");
  int needed_g_t_14[] = {  10}; //   1
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_17__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_17__32_12");
  int needed_g_t_15[] = {  11,   14}; //   2
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__32_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__32_76");
  int needed_g_t_16[] = {  11}; //   1
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__34_17__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__34_17__64_12");
  int needed_g_t_17[] = {  12,   17,   19,   20,   26,   39}; //   6
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_92");
  int needed_g_t_18[] = {  12,   20}; //   2
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__16_76");
  int needed_g_t_19[] = {  13,   16,   18,   21,   27,   38}; //   6
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_60");
  int needed_g_t_20[] = {  13,   21}; //   2
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__16_44");
  int needed_g_t_21[] = {  20}; //   1
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_18__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_18__64_12");
  int needed_g_t_22[] = {  21}; //   1
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_18__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_18__32_12");
  int needed_g_t_23[] = {  22}; //   1
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__17_2__32_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__17_2__32_76");
  int needed_g_t_24[] = {  23}; //   1
  psi_needed_g_t[no_ps][24] = get_vector_from_array_int(needed_g_t_24, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__17_2__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__17_2__64_44");
  int needed_g_t_25[] = {  24,   25}; //   2
  psi_needed_g_t[no_ps][25] = get_vector_from_array_int(needed_g_t_25, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__12_96");
  int needed_g_t_26[] = {  24}; //   1
  psi_needed_g_t[no_ps][26] = get_vector_from_array_int(needed_g_t_26, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_14__32_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_14__32_64");
  int needed_g_t_27[] = {  25}; //   1
  psi_needed_g_t[no_ps][27] = get_vector_from_array_int(needed_g_t_27, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_14__64_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_14__64_32");
  int needed_g_t_28[] = {  26,   39}; //   2
  psi_needed_g_t[no_ps][28] = get_vector_from_array_int(needed_g_t_28, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__12_80");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__12_80");
  int needed_g_t_29[] = {  26}; //   1
  psi_needed_g_t[no_ps][29] = get_vector_from_array_int(needed_g_t_29, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_14__64_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_14__64_16");
  int needed_g_t_30[] = {  27,   38}; //   2
  psi_needed_g_t[no_ps][30] = get_vector_from_array_int(needed_g_t_30, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__12_48");
  int needed_g_t_31[] = {  27}; //   1
  psi_needed_g_t[no_ps][31] = get_vector_from_array_int(needed_g_t_31, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_14__32_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_14__32_16");
  int needed_g_t_32[] = {  30,   34}; //   2
  psi_needed_g_t[no_ps][32] = get_vector_from_array_int(needed_g_t_32, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_76");
  int needed_g_t_33[] = {  31,   35}; //   2
  psi_needed_g_t[no_ps][33] = get_vector_from_array_int(needed_g_t_33, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__80_44");
  int needed_g_t_34[] = {  32,   33}; //   2
  psi_needed_g_t[no_ps][34] = get_vector_from_array_int(needed_g_t_34, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_112");
  int needed_g_t_35[] = {  32}; //   1
  psi_needed_g_t[no_ps][35] = get_vector_from_array_int(needed_g_t_35, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__48_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__48_64");
  int needed_g_t_36[] = {  33}; //   1
  psi_needed_g_t[no_ps][36] = get_vector_from_array_int(needed_g_t_36, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__80_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__80_32");
  int needed_g_t_37[] = {  34}; //   1
  psi_needed_g_t[no_ps][37] = get_vector_from_array_int(needed_g_t_37, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__12_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__12_64");
  int needed_g_t_38[] = {  35}; //   1
  psi_needed_g_t[no_ps][38] = get_vector_from_array_int(needed_g_t_38, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_81__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_81__12_32");
  int needed_g_t_39[] = {  36}; //   1
  psi_needed_g_t[no_ps][39] = get_vector_from_array_int(needed_g_t_39, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__48_76");
  int needed_g_t_40[] = {  37}; //   1
  psi_needed_g_t[no_ps][40] = get_vector_from_array_int(needed_g_t_40, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__80_44");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(9);
  psi_needed_g_d[no_ps].resize(9);
  int needed_g_d_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  40
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 40);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {   4,    6,   12,   14,   17,   22,   30,   36}; //   8
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 8);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_2[] = {   5,    7,   13,   15,   16,   23,   31,   37}; //   8
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 8);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_3[] = {   6,   17}; //   2
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 2);
  psi_container_IS_name.push_back("costheta_of_decay_92__16_76");
  psi_container_IS_name.push_back("phi_of_decay_92__16_76");
  int needed_g_d_4[] = {   7,   16}; //   2
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_5[] = {   8,   18}; //   2
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_6[] = {   8,   18,   28,   30,   32,   34,   36,   38}; //   8
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 8);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_7[] = {   9,   19}; //   2
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 2);
  psi_container_IS_name.push_back("costheta_of_decay_92__12_80");
  psi_container_IS_name.push_back("phi_of_decay_92__12_80");
  int needed_g_d_8[] = {   9,   19,   29,   31,   33,   35,   37,   39}; //   8
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 8);
  psi_container_IS_name.push_back("costheta_of_decay_80__16_64");
  psi_container_IS_name.push_back("phi_of_decay_80__16_64");

  psi_c_p[no_ps].resize(40);
  psi_c_f[no_ps].resize(40);
  psi_c_t[no_ps].resize(40);
  psi_c_d[no_ps].resize(40);

  int c_p_0[] = {  0}; //   1
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 1);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {  0}; //   1
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 1);

  int c_p_1[] = {  0}; //   1
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 1);
  int c_f_1[] = {  2,   3}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {  0}; //   1
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 1);

  int c_p_2[] = {  0}; //   1
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 1);
  int c_f_2[] = {  4,   5}; //   2
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 2);
  int c_t_2[] = {  6,   7,   8}; //   3
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 3);
  int c_d_2[] = {  0}; //   1
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 1);

  int c_p_3[] = {  0}; //   1
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 1);
  int c_f_3[] = {  4,   5}; //   2
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 2);
  int c_t_3[] = {  6,   7,   9}; //   3
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 3);
  int c_d_3[] = {  0}; //   1
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 1);

  int c_p_4[] = {  0,   1}; //   2
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 2);
  int c_f_4[] = {  6}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  6,  10}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  1,   0}; //   2
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 2);

  int c_p_5[] = {  0,   2}; //   2
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 2);
  int c_f_5[] = {  7}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = {  6,  11}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  2,   0}; //   2
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 2);

  int c_p_6[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  3}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  3,   1,   0}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  0,   2,   4}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  0}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  4,   2,   0}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  5,   6,   7}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  0}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  5,   0,   6}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  8,   9,  10}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  3}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  7,   0,   8}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = {  0}; //   1
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 1);
  int c_f_10[] = {  8,   7}; //   2
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 2);
  int c_t_10[] = { 12,  13,  14}; //   3
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 3);
  int c_d_10[] = {  0}; //   1
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 1);

  int c_p_11[] = {  0}; //   1
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 1);
  int c_f_11[] = {  9,   6}; //   2
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 2);
  int c_t_11[] = { 12,  15,  16}; //   3
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 3);
  int c_d_11[] = {  0}; //   1
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 1);

  int c_p_12[] = {  0,   1}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = { 10}; //   1
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 1);
  int c_t_12[] = { 17,  18}; //   2
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 2);
  int c_d_12[] = {  1,   0}; //   2
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 2);

  int c_p_13[] = {  0,   2}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = { 11}; //   1
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 1);
  int c_t_13[] = { 19,  20}; //   2
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 2);
  int c_d_13[] = {  2,   0}; //   2
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 2);

  int c_p_14[] = {  0,   1}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {  6}; //   1
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 1);
  int c_t_14[] = { 12,  15}; //   2
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 2);
  int c_d_14[] = {  1,   0}; //   2
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 2);

  int c_p_15[] = {  0,   2}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {  7}; //   1
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 1);
  int c_t_15[] = { 12,  13}; //   2
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 2);
  int c_d_15[] = {  2,   0}; //   2
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 2);

  int c_p_16[] = {  0,   2,   4}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = { 19}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = {  4,   2,   0}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = { 17}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = {  3,   1,   0}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  5,   6,   7}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = { 19}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = {  5,   0,   6}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = {  8,   9,  10}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = { 17}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = {  7,   0,   8}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = {  0}; //   1
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 1);
  int c_f_20[] = {  9,  10}; //   2
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 2);
  int c_t_20[] = { 17,  18,  21}; //   3
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 3);
  int c_d_20[] = {  0}; //   1
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 1);

  int c_p_21[] = {  0}; //   1
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 1);
  int c_f_21[] = {  8,  11}; //   2
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 2);
  int c_t_21[] = { 19,  20,  22}; //   3
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 3);
  int c_d_21[] = {  0}; //   1
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 1);

  int c_p_22[] = {  0,   1}; //   2
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 2);
  int c_f_22[] = {  6}; //   1
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 1);
  int c_t_22[] = { 12,  23}; //   2
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 2);
  int c_d_22[] = {  1,   0}; //   2
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 2);

  int c_p_23[] = {  0,   2}; //   2
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 2);
  int c_f_23[] = {  7}; //   1
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 1);
  int c_t_23[] = { 12,  24}; //   2
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 2);
  int c_d_23[] = {  2,   0}; //   2
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 2);

  int c_p_24[] = {  0}; //   1
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 1);
  int c_f_24[] = {  4,   5}; //   2
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 2);
  int c_t_24[] = { 12,  25,  26}; //   3
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 3);
  int c_d_24[] = {  0}; //   1
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 1);

  int c_p_25[] = {  0}; //   1
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 1);
  int c_f_25[] = {  4,   5}; //   2
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 2);
  int c_t_25[] = { 12,  25,  27}; //   3
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 3);
  int c_d_25[] = {  0}; //   1
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 1);

  int c_p_26[] = {  0}; //   1
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 1);
  int c_f_26[] = {  2,   3}; //   2
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 2);
  int c_t_26[] = { 17,  28,  29}; //   3
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 3);
  int c_d_26[] = {  0}; //   1
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 1);

  int c_p_27[] = {  0}; //   1
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 1);
  int c_f_27[] = {  0,   1}; //   2
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 2);
  int c_t_27[] = { 19,  30,  31}; //   3
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 3);
  int c_d_27[] = {  0}; //   1
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 1);

  int c_p_28[] = {  5,   6}; //   2
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 2);
  int c_f_28[] = {  1}; //   1
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 1);
  int c_t_28[] = {  0,   1}; //   2
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 2);
  int c_d_28[] = {  0,   6}; //   2
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 2);

  int c_p_29[] = {  8,   9}; //   2
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 2);
  int c_f_29[] = {  3}; //   1
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 1);
  int c_t_29[] = {  3,   4}; //   2
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 2);
  int c_d_29[] = {  0,   8}; //   2
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 2);

  int c_p_30[] = {  0,   1,  11}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = { 32}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = {  6,   1,   0}; //   3
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 3);

  int c_p_31[] = {  0,   2,  12}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = { 33}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = {  8,   2,   0}; //   3
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 3);

  int c_p_32[] = {  5,   6}; //   2
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 2);
  int c_f_32[] = { 12}; //   1
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 1);
  int c_t_32[] = { 34,  35}; //   2
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 2);
  int c_d_32[] = {  0,   6}; //   2
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 2);

  int c_p_33[] = {  8,   9}; //   2
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 2);
  int c_f_33[] = { 13}; //   1
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 1);
  int c_t_33[] = { 34,  36}; //   2
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 2);
  int c_d_33[] = {  0,   8}; //   2
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 2);

  int c_p_34[] = {  0,  13}; //   2
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 2);
  int c_f_34[] = { 14}; //   1
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 1);
  int c_t_34[] = { 32,  37}; //   2
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 2);
  int c_d_34[] = {  6,   0}; //   2
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 2);

  int c_p_35[] = {  0,  14}; //   2
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 2);
  int c_f_35[] = { 15}; //   1
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 1);
  int c_t_35[] = { 33,  38}; //   2
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 2);
  int c_d_35[] = {  8,   0}; //   2
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 2);

  int c_p_36[] = {  5,   6,  15}; //   3
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 3);
  int c_f_36[] = {}; //   0
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 0);
  int c_t_36[] = { 39}; //   1
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 1);
  int c_d_36[] = {  1,   0,   6}; //   3
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 3);

  int c_p_37[] = {  8,   9,  16}; //   3
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 3);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = { 40}; //   1
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 1);
  int c_d_37[] = {  2,   0,   8}; //   3
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 3);

  int c_p_38[] = {  0,  13}; //   2
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 2);
  int c_f_38[] = {  1}; //   1
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 1);
  int c_t_38[] = { 19,  30}; //   2
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 2);
  int c_d_38[] = {  6,   0}; //   2
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 2);

  int c_p_39[] = {  0,  14}; //   2
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 2);
  int c_f_39[] = {  3}; //   1
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 1);
  int c_t_39[] = { 17,  28}; //   2
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 2);
  int c_d_39[] = {  8,   0}; //   2
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
