#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_ax_psp_220_bbx_wpwmddx(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_ax_psp_220_bbx_wpwmddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(10);
  psi_needed_v_smin[no_ps].resize(10);
  int needed_v_smin_0[] = {   0,    8,    9,   10,   11,   12,   13,   14,   15}; //   9
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 9);
  int needed_v_smin_1[] = {   1,    7}; //   2
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   1}; //   1
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 1);
  int needed_v_smin_3[] = {   2,    3,    4,    5,   10,   11,   12,   13,   14,   15}; //  10
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 10);
  int needed_v_smin_4[] = {   2,    3}; //   2
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 2);
  int needed_v_smin_5[] = {   4,    5}; //   2
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 2);
  int needed_v_smin_6[] = {   6,    7}; //   2
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 2);
  int needed_v_smin_7[] = {   6}; //   1
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 1);
  int needed_v_smin_8[] = {   0}; //   1
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 1);
  int needed_v_smin_9[] = {   8,    9}; //   2
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 2);

  psi_v_smax[no_ps].resize(11);
  psi_needed_v_smax[no_ps].resize(11);
  int needed_v_smax_0[] = {   0,    8,    9,   10,   11,   12}; //   6
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 6);
  int needed_v_smax_1[] = {   1,    7}; //   2
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   1,    2,    3}; //   3
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 3);
  int needed_v_smax_3[] = {   2,    3,    4,    5,   13,   14,   15}; //   7
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 7);
  int needed_v_smax_4[] = {   4,    5,    6}; //   3
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 3);
  int needed_v_smax_5[] = {   6}; //   1
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 1);
  int needed_v_smax_6[] = {   7}; //   1
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 1);
  int needed_v_smax_7[] = {  10,   11,   12}; //   3
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 3);
  int needed_v_smax_8[] = {  13,   14,   15}; //   3
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 3);
  int needed_v_smax_9[] = {   0}; //   1
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 1);
  int needed_v_smax_10[] = {   8,    9}; //   2
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(15);
  psi_needed_g_p[no_ps].resize(15);
  int needed_g_p_0[] = {   0,    8,    9,   10,   11,   12}; //   6
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 6);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   1,    7}; //   2
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   1}; //   1
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 1);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   2,    4,   13}; //   3
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 3);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {   2,    3}; //   2
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax2");
  int needed_g_p_5[] = {   3,    5,   14}; //   3
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 3);
  psi_container_IS_name.push_back("propagator_23_smin3_smax3");
  int needed_g_p_6[] = {   4,    5}; //   2
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_7[] = {   6}; //   1
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 1);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_8[] = {   6}; //   1
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 1);
  psi_container_IS_name.push_back("propagator_0_smin7_smax4");
  int needed_g_p_9[] = {   7}; //   1
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 1);
  psi_container_IS_name.push_back("propagator_0_smin6_smax6");
  int needed_g_p_10[] = {  10}; //   1
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 1);
  psi_container_IS_name.push_back("propagator_0_smin3_smax7");
  int needed_g_p_11[] = {  11}; //   1
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 1);
  psi_container_IS_name.push_back("propagator_23_smin3_smax7");
  int needed_g_p_12[] = {  12}; //   1
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 1);
  psi_container_IS_name.push_back("propagator_25_smin3_smax7");
  int needed_g_p_13[] = {  13,   14,   15}; //   3
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 3);
  psi_container_IS_name.push_back("propagator_0_smin0_smax8");
  int needed_g_p_14[] = {  15}; //   1
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 1);
  psi_container_IS_name.push_back("propagator_25_smin3_smax3");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(2);
  psi_needed_g_f[no_ps].resize(2);
  int needed_g_f_0[] = {   0}; //   1
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax9");
  int needed_g_f_1[] = {   8,    9}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax10");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(7);
  psi_needed_g_t[no_ps].resize(7);
  int needed_g_t_0[] = {   0}; //   1
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_1__4_56");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_1__4_56");
  int needed_g_t_1[] = {   0}; //   1
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_6__48_8");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_6__48_8");
  int needed_g_t_2[] = {   8,    9}; //   2
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__8_52");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__8_52");
  int needed_g_t_3[] = {   8}; //   1
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_9__4_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_9__4_48");
  int needed_g_t_4[] = {   9}; //   1
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_9__48_4");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_9__48_4");
  int needed_g_t_5[] = {  10,   11,   12}; //   3
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_2__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_2__12_48");
  int needed_g_t_6[] = {  13,   14,   15}; //   3
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_2__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_2__48_12");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(11);
  psi_needed_g_d[no_ps].resize(11);
  int needed_g_d_0[] = {   0,    8,    9,   10,   11,   12,   13,   14,   15}; //   9
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 9);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_1[] = {   1,    2,    3}; //   3
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 3);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_2[] = {   1}; //   1
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 1);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_3[] = {   1,    7}; //   2
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 2);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_4[] = {   2,    3}; //   2
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_5[] = {   2,    3,    4,    5,   10,   11,   12,   13,   14,   15}; //  10
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 10);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_6[] = {   4,    5,    6}; //   3
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 3);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_7[] = {   4,    5}; //   2
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_8[] = {   6}; //   1
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 1);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_9[] = {   6,    7}; //   2
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 2);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_10[] = {   7}; //   1
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 1);
  psi_container_IS_name.push_back("costheta_of_decay_60__20_40");
  psi_container_IS_name.push_back("phi_of_decay_60__20_40");

  psi_c_p[no_ps].resize(16);
  psi_c_f[no_ps].resize(16);
  psi_c_t[no_ps].resize(16);
  psi_c_d[no_ps].resize(16);

  int c_p_0[] = {  0}; //   1
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 1);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {  0}; //   1
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 1);

  int c_p_1[] = {  1,   2}; //   2
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 2);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {}; //   0
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 0);
  int c_d_1[] = {  1,   2,   3}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  3,   4}; //   2
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 2);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {}; //   0
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 0);
  int c_d_2[] = {  1,   4,   5}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  5,   4}; //   2
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 2);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {}; //   0
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 0);
  int c_d_3[] = {  1,   4,   5}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  3,   6}; //   2
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 2);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {}; //   0
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 0);
  int c_d_4[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  5,   6}; //   2
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 2);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {}; //   0
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 0);
  int c_d_5[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  7,   8}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = {  6,   8,   9}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  1,   9}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {}; //   0
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 0);
  int c_d_7[] = { 10,   9,   3}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  0}; //   1
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 1);
  int c_f_8[] = {  1}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = {  2,   3}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = {  0}; //   1
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 1);

  int c_p_9[] = {  0}; //   1
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 1);
  int c_f_9[] = {  1}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = {  2,   4}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = {  0}; //   1
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 1);

  int c_p_10[] = {  0,  10}; //   2
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 2);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  5}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  5,   0}; //   2
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 2);

  int c_p_11[] = {  0,  11}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  5}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  5,   0}; //   2
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 2);

  int c_p_12[] = {  0,  12}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  5}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  5,   0}; //   2
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 2);

  int c_p_13[] = {  3,  13}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  6}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  0,   5}; //   2
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 2);

  int c_p_14[] = {  5,  13}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  6}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  0,   5}; //   2
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 2);

  int c_p_15[] = { 14,  13}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  6}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  0,   5}; //   2
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
