#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_ax_psp_220_dd_wpwmdd(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_ax_psp_220_dd_wpwmdd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(9);
  psi_needed_v_smin[no_ps].resize(9);
  int needed_v_smin_0[] = {   4,    5,    6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   24,   25,   26,   27}; //  16
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 16);
  int needed_v_smin_1[] = {   8,    9,   18,   19,    6,    7,   24,   25}; //   8
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 8);
  int needed_v_smin_2[] = {  10,   11,   20,   21,    4,    5,   26,   27}; //   8
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 8);
  int needed_v_smin_3[] = {  12,   14,   16,   22,    1,    2}; //   6
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 6);
  int needed_v_smin_4[] = {  12,   22,    1,   14}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {  13,   15,   17,   23,    0,    3}; //   6
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 6);
  int needed_v_smin_6[] = {  13,   23,    0,   15}; //   4
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 4);
  int needed_v_smin_7[] = {   2,   16}; //   2
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 2);
  int needed_v_smin_8[] = {   3,   17}; //   2
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 2);

  psi_v_smax[no_ps].resize(6);
  psi_needed_v_smax[no_ps].resize(6);
  int needed_v_smax_0[] = {   4,    5,    6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   24,   25,   26,   27}; //  16
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 16);
  int needed_v_smax_1[] = {   8,    9,   13,   18,   19,   23,    0,    6,    7,   15,   24,   25}; //  12
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 12);
  int needed_v_smax_2[] = {  10,   11,   12,   20,   21,   22,    1,    4,    5,   14,   26,   27}; //  12
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 12);
  int needed_v_smax_3[] = {  12,   14,   16,   22,    1,    2}; //   6
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 6);
  int needed_v_smax_4[] = {  13,   15,   17,   23,    0,    3}; //   6
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 6);
  int needed_v_smax_5[] = {   2,    3,   16,   17}; //   4
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 4);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(8);
  psi_needed_g_p[no_ps].resize(8);
  int needed_g_p_0[] = {   4,    6,    8,   10,   18,   20,   24,   26}; //   8
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 8);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   5,    7,    9,   11,   19,   21,   25,   27}; //   8
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 8);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_2[] = {   8,    9,   18,   19}; //   4
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 4);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_3[] = {  10,   11,   20,   21}; //   4
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 4);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_4[] = {  12,   14,   16,   22}; //   4
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 4);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_5[] = {  12,   22}; //   2
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax2");
  int needed_g_p_6[] = {  13,   15,   17,   23}; //   4
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 4);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_7[] = {  13,   23}; //   2
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 2);
  psi_container_IS_name.push_back("propagator_0_smin6_smax1");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(8);
  psi_needed_g_f[no_ps].resize(8);
  int needed_g_f_0[] = {   0,    3}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax4");
  int needed_g_f_1[] = {   0,   15}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax1");
  int needed_g_f_2[] = {   1,    2}; //   2
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax3");
  int needed_g_f_3[] = {   1,   14}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax2");
  int needed_g_f_4[] = {   2,   16}; //   2
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax5");
  int needed_g_f_5[] = {   3,   17}; //   2
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax5");
  int needed_g_f_6[] = {   4,    5,   26,   27}; //   4
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax2");
  int needed_g_f_7[] = {   6,    7,   24,   25}; //   4
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax1");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(17);
  psi_needed_g_t[no_ps].resize(17);
  int needed_g_t_0[] = {   0,   15,   18,   19,   23,   24,   25}; //   7
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 7);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_44");
  int needed_g_t_1[] = {   0,   15}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__8_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__8_36");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_10__32_4");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_10__32_4");
  int needed_g_t_3[] = {   1,   14,   20,   21,   22,   26,   27}; //   7
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 7);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_28");
  int needed_g_t_4[] = {   1,   14}; //   2
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__8_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__8_20");
  int needed_g_t_5[] = {   1}; //   1
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_10__16_4");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_10__16_4");
  int needed_g_t_6[] = {   2,    3,   16,   17}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__8_52");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__8_52");
  int needed_g_t_7[] = {   2,   16}; //   2
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_9__32_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_9__32_20");
  int needed_g_t_8[] = {   2}; //   1
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__9_34__4_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__9_34__4_16");
  int needed_g_t_9[] = {   3,   17}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_9__16_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_9__16_36");
  int needed_g_t_10[] = {   3}; //   1
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__9_18__4_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__9_18__4_32");
  int needed_g_t_11[] = {   4,    5,   10,   11,   12}; //   5
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 5);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_28");
  int needed_g_t_12[] = {   4,    5}; //   2
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_34__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_34__12_16");
  int needed_g_t_13[] = {   6,    7,    8,    9,   13}; //   5
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 5);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_44");
  int needed_g_t_14[] = {   6,    7}; //   2
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__12_32");
  int needed_g_t_15[] = {  24,   25}; //   2
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__12_32");
  int needed_g_t_16[] = {  26,   27}; //   2
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__12_16");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(7);
  psi_needed_g_d[no_ps].resize(7);
  int needed_g_d_0[] = {   4,    5,    6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   24,   25,   26,   27}; //  16
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 16);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {   8,    9,   18,   19}; //   4
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 4);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_2[] = {  10,   11,   20,   21}; //   4
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_3[] = {  12,   22}; //   2
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_4[] = {  12,   14,   16,   22}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_5[] = {  13,   23}; //   2
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__8_36");
  psi_container_IS_name.push_back("phi_of_decay_44__8_36");
  int needed_g_d_6[] = {  13,   15,   17,   23}; //   4
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 4);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");

  psi_c_p[no_ps].resize(28);
  psi_c_f[no_ps].resize(28);
  psi_c_t[no_ps].resize(28);
  psi_c_d[no_ps].resize(28);

  int c_p_0[] = {}; //   0
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 0);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {}; //   0
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 0);

  int c_p_1[] = {}; //   0
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 0);
  int c_f_1[] = {  2,   3}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {}; //   0
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 0);

  int c_p_2[] = {}; //   0
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 0);
  int c_f_2[] = {  2,   4}; //   2
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 2);
  int c_t_2[] = {  6,   7,   8}; //   3
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 3);
  int c_d_2[] = {}; //   0
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 0);

  int c_p_3[] = {}; //   0
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 0);
  int c_f_3[] = {  0,   5}; //   2
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 2);
  int c_t_3[] = {  6,   9,  10}; //   3
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 3);
  int c_d_3[] = {}; //   0
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 0);

  int c_p_4[] = {  0}; //   1
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 1);
  int c_f_4[] = {  6}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = { 11,  12}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  0}; //   1
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 1);

  int c_p_5[] = {  1}; //   1
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 1);
  int c_f_5[] = {  6}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = { 11,  12}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  0}; //   1
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 1);

  int c_p_6[] = {  0}; //   1
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 1);
  int c_f_6[] = {  7}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = { 13,  14}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  0}; //   1
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 1);

  int c_p_7[] = {  1}; //   1
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 1);
  int c_f_7[] = {  7}; //   1
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 1);
  int c_t_7[] = { 13,  14}; //   2
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 2);
  int c_d_7[] = {  0}; //   1
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 1);

  int c_p_8[] = {  0,   2}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = { 13}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  1,   0}; //   2
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 2);

  int c_p_9[] = {  1,   2}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = { 13}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  1,   0}; //   2
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 2);

  int c_p_10[] = {  0,   3}; //   2
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 2);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = { 11}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  2,   0}; //   2
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 2);

  int c_p_11[] = {  1,   3}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = { 11}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  2,   0}; //   2
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 2);

  int c_p_12[] = {  4,   5}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = { 11}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  3,   4}; //   2
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 2);

  int c_p_13[] = {  6,   7}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = { 13}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  5,   6}; //   2
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 2);

  int c_p_14[] = {  4}; //   1
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 1);
  int c_f_14[] = {  3}; //   1
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 1);
  int c_t_14[] = {  3,   4}; //   2
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 2);
  int c_d_14[] = {  4}; //   1
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 1);

  int c_p_15[] = {  6}; //   1
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 1);
  int c_f_15[] = {  1}; //   1
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 1);
  int c_t_15[] = {  0,   1}; //   2
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 2);
  int c_d_15[] = {  6}; //   1
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 1);

  int c_p_16[] = {  4}; //   1
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 1);
  int c_f_16[] = {  4}; //   1
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 1);
  int c_t_16[] = {  6,   7}; //   2
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 2);
  int c_d_16[] = {  4}; //   1
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 1);

  int c_p_17[] = {  6}; //   1
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 1);
  int c_f_17[] = {  5}; //   1
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 1);
  int c_t_17[] = {  6,   9}; //   2
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 2);
  int c_d_17[] = {  6}; //   1
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 1);

  int c_p_18[] = {  0,   2}; //   2
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 2);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {  0}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = {  1,   0}; //   2
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 2);

  int c_p_19[] = {  1,   2}; //   2
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 2);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {  0}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = {  1,   0}; //   2
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 2);

  int c_p_20[] = {  0,   3}; //   2
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 2);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {  3}; //   1
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 1);
  int c_d_20[] = {  2,   0}; //   2
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 2);

  int c_p_21[] = {  1,   3}; //   2
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 2);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {  3}; //   1
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 1);
  int c_d_21[] = {  2,   0}; //   2
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 2);

  int c_p_22[] = {  4,   5}; //   2
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 2);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {  3}; //   1
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 1);
  int c_d_22[] = {  3,   4}; //   2
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 2);

  int c_p_23[] = {  6,   7}; //   2
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 2);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {  0}; //   1
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 1);
  int c_d_23[] = {  5,   6}; //   2
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 2);

  int c_p_24[] = {  0}; //   1
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 1);
  int c_f_24[] = {  7}; //   1
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 1);
  int c_t_24[] = {  0,  15}; //   2
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 2);
  int c_d_24[] = {  0}; //   1
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 1);

  int c_p_25[] = {  1}; //   1
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 1);
  int c_f_25[] = {  7}; //   1
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 1);
  int c_t_25[] = {  0,  15}; //   2
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 2);
  int c_d_25[] = {  0}; //   1
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 1);

  int c_p_26[] = {  0}; //   1
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 1);
  int c_f_26[] = {  6}; //   1
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 1);
  int c_t_26[] = {  3,  16}; //   2
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 2);
  int c_d_26[] = {  0}; //   1
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 1);

  int c_p_27[] = {  1}; //   1
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 1);
  int c_f_27[] = {  6}; //   1
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 1);
  int c_t_27[] = {  3,  16}; //   2
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 2);
  int c_d_27[] = {  0}; //   1
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 1);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
