#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_ax_psp_220_gg_wpwmbbx(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_ax_psp_220_gg_wpwmbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(7);
  psi_needed_v_smin[no_ps].resize(7);
  int needed_v_smin_0[] = {   2,   11,   19,   20,   34,   36,   37,   38}; //   8
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 8);
  int needed_v_smin_1[] = {   3,    4,   12,   20,   27,   35,   37,   38}; //   8
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 8);
  int needed_v_smin_2[] = {   4,   12,   27,    3,   35}; //   5
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 5);
  int needed_v_smin_3[] = {   5,    6,    7,    8,    9,   10,   13,   14,   15,   16,   17,   18,   21,   22,   23,   24,   25,   26,   28,   29,   30,   31,   32,   33,    0,    1}; //  26
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 26);
  int needed_v_smin_4[] = {   5,    6,    7,   13,   14,   15,   28,   29,   30,    0,   24,   25,   26}; //  13
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 13);
  int needed_v_smin_5[] = {   8,    9,   10,   16,   17,   18,   31,   32,   33,    1,   21,   22,   23}; //  13
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 13);
  int needed_v_smin_6[] = {  11,   19,   34,    2,   36}; //   5
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 5);

  psi_v_smax[no_ps].resize(7);
  psi_needed_v_smax[no_ps].resize(7);
  int needed_v_smax_0[] = {   2,   11,   19,   34,   36,   38}; //   6
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 6);
  int needed_v_smax_1[] = {   3,    4,   12,   20,   27,   35,   37}; //   7
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 7);
  int needed_v_smax_2[] = {   4,    5,    6,    7,   12,   13,   14,   15,   27,   28,   29,   30,    0,    3,   24,   25,   26,   35}; //  18
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 18);
  int needed_v_smax_3[] = {   5,    6,    7,    8,    9,   10,   13,   14,   15,   16,   17,   18,   21,   22,   23,   24,   25,   26,   28,   29,   30,   31,   32,   33,    0,    1}; //  26
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 26);
  int needed_v_smax_4[] = {   8,    9,   10,   11,   16,   17,   18,   19,   31,   32,   33,   34,    1,    2,   21,   22,   23,   36}; //  18
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 18);
  int needed_v_smax_5[] = {  20,   37}; //   2
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 2);
  int needed_v_smax_6[] = {  38}; //   1
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 1);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(11);
  psi_needed_g_p[no_ps].resize(11);
  int needed_g_p_0[] = {   2,   11,   19,   34,   36,   38}; //   6
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 6);
  psi_container_IS_name.push_back("propagator_6_smin0_smax0");
  int needed_g_p_1[] = {   3,    4,   12,   20,   27,   35,   37}; //   7
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 7);
  psi_container_IS_name.push_back("propagator_6_smin1_smax1");
  int needed_g_p_2[] = {   4,   12,   27}; //   3
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 3);
  psi_container_IS_name.push_back("propagator_5_smin2_smax2");
  int needed_g_p_3[] = {   5,    8,   13,   16,   21,   24,   28,   31}; //   8
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 8);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {   5,    6,    7,   13,   14,   15,   28,   29,   30}; //   9
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 9);
  psi_container_IS_name.push_back("propagator_5_smin4_smax2");
  int needed_g_p_5[] = {   6,    9,   14,   17,   22,   25,   29,   32}; //   8
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 8);
  psi_container_IS_name.push_back("propagator_23_smin3_smax3");
  int needed_g_p_6[] = {   7,   10,   15,   18,   23,   26,   30,   33}; //   8
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 8);
  psi_container_IS_name.push_back("propagator_25_smin3_smax3");
  int needed_g_p_7[] = {   8,    9,   10,   16,   17,   18,   31,   32,   33}; //   9
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 9);
  psi_container_IS_name.push_back("propagator_5_smin5_smax4");
  int needed_g_p_8[] = {  11,   19,   34}; //   3
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 3);
  psi_container_IS_name.push_back("propagator_5_smin6_smax4");
  int needed_g_p_9[] = {  20,   37}; //   2
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 2);
  psi_container_IS_name.push_back("propagator_6_smin0_smax5");
  int needed_g_p_10[] = {  38}; //   1
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 1);
  psi_container_IS_name.push_back("propagator_6_smin1_smax6");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(5);
  psi_needed_g_f[no_ps].resize(5);
  int needed_g_f_0[] = {   0,    1}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax3");
  int needed_g_f_1[] = {   0,   24,   25,   26}; //   4
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax2");
  int needed_g_f_2[] = {   1,   21,   22,   23}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax4");
  int needed_g_f_3[] = {   2,   36}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax4");
  int needed_g_f_4[] = {   3,   35}; //   2
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax2");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(14);
  psi_needed_g_t[no_ps].resize(14);
  int needed_g_t_0[] = {   0,   24,   25,   26,   27,   28,   29,   30,   35}; //   9
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 9);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_2__16_44");
  int needed_g_t_1[] = {   0,   24,   25,   26}; //   4
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_17__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_17__32_12");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_6__17_34__4_8");
  psi_container_IS_name.push_back("phi_of_tchannel_6__17_34__4_8");
  int needed_g_t_3[] = {   1,   21,   22,   23,   31,   32,   33,   34,   36}; //   9
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 9);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_2__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_2__32_28");
  int needed_g_t_4[] = {   1,   21,   22,   23}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_33__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_33__16_12");
  int needed_g_t_5[] = {   1}; //   1
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 1);
  psi_container_IS_name.push_back("t_of_tchannel_6__33_18__8_4");
  psi_container_IS_name.push_back("phi_of_tchannel_6__33_18__8_4");
  int needed_g_t_6[] = {   2,    8,    9,   10,   11}; //   5
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 5);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_1__32_28");
  int needed_g_t_7[] = {   2}; //   1
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_34__20_8");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_34__20_8");
  int needed_g_t_8[] = {   3,    4,    5,    6,    7}; //   5
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 5);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_1__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_1__16_44");
  int needed_g_t_9[] = {   3}; //   1
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_18__40_4");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_18__40_4");
  int needed_g_t_10[] = {  35}; //   1
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_17__40_4");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_17__40_4");
  int needed_g_t_11[] = {  36}; //   1
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_33__20_8");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_33__20_8");
  int needed_g_t_12[] = {  37}; //   1
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__20_40");
  int needed_g_t_13[] = {  38}; //   1
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__40_20");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(10);
  psi_needed_g_d[no_ps].resize(10);
  int needed_g_d_0[] = {   2,   11,   19,   20,   34,   36,   37,   38}; //   8
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 8);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_1[] = {   3,    4,   12,   20,   27,   35,   37,   38}; //   8
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 8);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_2[] = {   4,   12,   27}; //   3
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 3);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_3[] = {   5,    6,    7,   13,   14,   15,   28,   29,   30}; //   9
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 9);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_4[] = {   5,    6,    7,    8,    9,   10,   13,   14,   15,   16,   17,   18,   21,   22,   23,   24,   25,   26,   28,   29,   30,   31,   32,   33}; //  24
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 24);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_5[] = {   8,    9,   10,   16,   17,   18,   31,   32,   33}; //   9
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 9);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_6[] = {  11,   19,   34}; //   3
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 3);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_7[] = {  12,   13,   14,   15}; //   4
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_8[] = {  16,   17,   18,   19}; //   4
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_9[] = {  20}; //   1
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 1);
  psi_container_IS_name.push_back("costheta_of_decay_60__20_40");
  psi_container_IS_name.push_back("phi_of_decay_60__20_40");

  psi_c_p[no_ps].resize(39);
  psi_c_f[no_ps].resize(39);
  psi_c_t[no_ps].resize(39);
  psi_c_d[no_ps].resize(39);

  int c_p_0[] = {}; //   0
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 0);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {}; //   0
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 0);

  int c_p_1[] = {}; //   0
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 0);
  int c_f_1[] = {  0,   2}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {}; //   0
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 0);

  int c_p_2[] = {  0}; //   1
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 1);
  int c_f_2[] = {  3}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  6,   7}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  0}; //   1
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 1);

  int c_p_3[] = {  1}; //   1
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 1);
  int c_f_3[] = {  4}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  8,   9}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  1}; //   1
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 1);

  int c_p_4[] = {  1,   2}; //   2
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 2);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {  8}; //   1
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 1);
  int c_d_4[] = {  2,   1}; //   2
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 2);

  int c_p_5[] = {  3,   4}; //   2
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 2);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {  8}; //   1
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 1);
  int c_d_5[] = {  3,   4}; //   2
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 2);

  int c_p_6[] = {  5,   4}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  8}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  3,   4}; //   2
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 2);

  int c_p_7[] = {  6,   4}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  8}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  3,   4}; //   2
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 2);

  int c_p_8[] = {  3,   7}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  6}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  5,   4}; //   2
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 2);

  int c_p_9[] = {  5,   7}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  6}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  5,   4}; //   2
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 2);

  int c_p_10[] = {  6,   7}; //   2
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 2);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  6}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  5,   4}; //   2
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 2);

  int c_p_11[] = {  0,   8}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  6}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  6,   0}; //   2
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 2);

  int c_p_12[] = {  1,   2}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {}; //   0
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 0);
  int c_d_12[] = {  7,   2,   1}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  3,   4}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {}; //   0
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 0);
  int c_d_13[] = {  7,   3,   4}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = {  5,   4}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {}; //   0
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 0);
  int c_d_14[] = {  7,   3,   4}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  6,   4}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {}; //   0
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 0);
  int c_d_15[] = {  7,   3,   4}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  3,   7}; //   2
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 2);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {}; //   0
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 0);
  int c_d_16[] = {  8,   5,   4}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  5,   7}; //   2
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 2);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {}; //   0
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 0);
  int c_d_17[] = {  8,   5,   4}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  6,   7}; //   2
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 2);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {}; //   0
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 0);
  int c_d_18[] = {  8,   5,   4}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = {  0,   8}; //   2
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 2);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {}; //   0
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 0);
  int c_d_19[] = {  8,   6,   0}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = {  1,   9}; //   2
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 2);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {}; //   0
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 0);
  int c_d_20[] = {  9,   0,   1}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = {  3}; //   1
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 1);
  int c_f_21[] = {  2}; //   1
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 1);
  int c_t_21[] = {  3,   4}; //   2
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 2);
  int c_d_21[] = {  4}; //   1
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 1);

  int c_p_22[] = {  5}; //   1
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 1);
  int c_f_22[] = {  2}; //   1
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 1);
  int c_t_22[] = {  3,   4}; //   2
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 2);
  int c_d_22[] = {  4}; //   1
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 1);

  int c_p_23[] = {  6}; //   1
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 1);
  int c_f_23[] = {  2}; //   1
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 1);
  int c_t_23[] = {  3,   4}; //   2
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 2);
  int c_d_23[] = {  4}; //   1
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 1);

  int c_p_24[] = {  3}; //   1
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 1);
  int c_f_24[] = {  1}; //   1
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 1);
  int c_t_24[] = {  0,   1}; //   2
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 2);
  int c_d_24[] = {  4}; //   1
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 1);

  int c_p_25[] = {  5}; //   1
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 1);
  int c_f_25[] = {  1}; //   1
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 1);
  int c_t_25[] = {  0,   1}; //   2
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 2);
  int c_d_25[] = {  4}; //   1
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 1);

  int c_p_26[] = {  6}; //   1
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 1);
  int c_f_26[] = {  1}; //   1
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 1);
  int c_t_26[] = {  0,   1}; //   2
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 2);
  int c_d_26[] = {  4}; //   1
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 1);

  int c_p_27[] = {  1,   2}; //   2
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 2);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  0}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = {  2,   1}; //   2
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 2);

  int c_p_28[] = {  3,   4}; //   2
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 2);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  0}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = {  3,   4}; //   2
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 2);

  int c_p_29[] = {  5,   4}; //   2
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 2);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  0}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = {  3,   4}; //   2
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 2);

  int c_p_30[] = {  6,   4}; //   2
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 2);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {  0}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = {  3,   4}; //   2
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 2);

  int c_p_31[] = {  3,   7}; //   2
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 2);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {  3}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = {  5,   4}; //   2
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 2);

  int c_p_32[] = {  5,   7}; //   2
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 2);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {  3}; //   1
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 1);
  int c_d_32[] = {  5,   4}; //   2
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 2);

  int c_p_33[] = {  6,   7}; //   2
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 2);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {  3}; //   1
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 1);
  int c_d_33[] = {  5,   4}; //   2
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 2);

  int c_p_34[] = {  0,   8}; //   2
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 2);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {  3}; //   1
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 1);
  int c_d_34[] = {  6,   0}; //   2
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 2);

  int c_p_35[] = {  1}; //   1
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 1);
  int c_f_35[] = {  4}; //   1
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 1);
  int c_t_35[] = {  0,  10}; //   2
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 2);
  int c_d_35[] = {  1}; //   1
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 1);

  int c_p_36[] = {  0}; //   1
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 1);
  int c_f_36[] = {  3}; //   1
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 1);
  int c_t_36[] = {  3,  11}; //   2
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 2);
  int c_d_36[] = {  0}; //   1
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 1);

  int c_p_37[] = {  1,   9}; //   2
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 2);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = { 12}; //   1
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 1);
  int c_d_37[] = {  0,   1}; //   2
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 2);

  int c_p_38[] = {  0,  10}; //   2
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 2);
  int c_f_38[] = {}; //   0
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 0);
  int c_t_38[] = { 13}; //   1
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 1);
  int c_d_38[] = {  1,   0}; //   2
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
