#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppzz02/header/ppzz02.phasespace.h"
void ppzz02_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppzz02_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppzz02_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppzz02_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 86;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 40;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 20;}
  else if (psi_no_map[no_ps] == 10){n_channel = 20;}
  else if (psi_no_map[no_ps] == 11){n_channel = 20;}
  else if (psi_no_map[no_ps] == 13){n_channel = 30;}
  else if (psi_no_map[no_ps] == 14){n_channel = 40;}
  else if (psi_no_map[no_ps] == 15){n_channel = 20;}
  else if (psi_no_map[no_ps] == 16){n_channel = 20;}
  else if (psi_no_map[no_ps] == 17){n_channel = 20;}
  else if (psi_no_map[no_ps] == 18){n_channel = 20;}
  else if (psi_no_map[no_ps] == 20){n_channel = 20;}
  else if (psi_no_map[no_ps] == 22){n_channel = 20;}
  else if (psi_no_map[no_ps] == 23){n_channel = 40;}
  else if (psi_no_map[no_ps] == 24){n_channel = 20;}
  else if (psi_no_map[no_ps] == 25){n_channel = 20;}
  else if (psi_no_map[no_ps] == 27){n_channel = 30;}
  else if (psi_no_map[no_ps] == 28){n_channel = 20;}
  else if (psi_no_map[no_ps] == 29){n_channel = 40;}
  else if (psi_no_map[no_ps] == 30){n_channel = 20;}
  else if (psi_no_map[no_ps] == 31){n_channel = 20;}
  else if (psi_no_map[no_ps] == 32){n_channel = 20;}
  else if (psi_no_map[no_ps] == 34){n_channel = 20;}
  else if (psi_no_map[no_ps] == 35){n_channel = 40;}
  else if (psi_no_map[no_ps] == 36){n_channel = 20;}
  else if (psi_no_map[no_ps] == 37){n_channel = 20;}
  else if (psi_no_map[no_ps] == 38){n_channel = 20;}
  else if (psi_no_map[no_ps] == 40){n_channel = 40;}
  else if (psi_no_map[no_ps] == 41){n_channel = 20;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppzz02_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppzz02_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppzz02_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppzz02_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppzz02_ax_psp_220_gg_zzddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppzz02_ax_psp_220_gg_zzuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppzz02_ax_psp_220_gd_zzgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppzz02_ax_psp_220_gu_zzgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppzz02_ax_psp_220_gdx_zzgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppzz02_ax_psp_220_gux_zzgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppzz02_ax_psp_220_dd_zzdd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppzz02_ax_psp_220_du_zzdu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppzz02_ax_psp_220_ds_zzds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppzz02_ax_psp_220_dc_zzdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppzz02_ax_psp_220_ddx_zzgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppzz02_ax_psp_220_ddx_zzddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppzz02_ax_psp_220_ddx_zzuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppzz02_ax_psp_220_ddx_zzssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppzz02_ax_psp_220_ddx_zzccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppzz02_ax_psp_220_dux_zzdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppzz02_ax_psp_220_dsx_zzdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppzz02_ax_psp_220_dcx_zzdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppzz02_ax_psp_220_uu_zzuu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppzz02_ax_psp_220_uc_zzuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppzz02_ax_psp_220_udx_zzudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppzz02_ax_psp_220_uux_zzgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppzz02_ax_psp_220_uux_zzddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppzz02_ax_psp_220_uux_zzuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppzz02_ax_psp_220_uux_zzssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppzz02_ax_psp_220_uux_zzccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppzz02_ax_psp_220_usx_zzusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppzz02_ax_psp_220_ucx_zzucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppzz02_ax_psp_220_dxdx_zzdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppzz02_ax_psp_220_dxux_zzdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppzz02_ax_psp_220_dxsx_zzdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppzz02_ax_psp_220_dxcx_zzdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppzz02_ax_psp_220_uxux_zzuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppzz02_ax_psp_220_uxcx_zzuxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
