#include "../include/classes.cxx"
////////////////////
//  constructors  //
////////////////////
multichannel_set::multichannel_set(){}

//multichannel_set::multichannel_set(multichannel_set ms){}

multichannel_set::multichannel_set(int _n_channel){
  // should not be used !!!
  n_channel = _n_channel;
  n_alpha_events = 100000;
  n_alpha_steps = 10;
  switch_minimum_weight = 1;
  limit_minimum_weight = 0.0001;
  reserved_minimum_weight = 0.001;

  active_optimization = 0;
  end_optimization = 0; // !!!
  //  reserved_minimum_weight = 0.001; // option to change via input ???

  alpha.resize(n_channel, 1. / double (n_channel));
  beta.resize(n_channel, 0.);
  beta[0] = alpha[0];
  for (int i = 1; i < beta.size(); i++){beta[i] = beta[i - 1] + alpha[i];}

  n_acc_channel.resize(n_channel, 0);
  n_rej_channel.resize(n_channel, 0);
  
  g_channel.resize(n_channel, 0.);
  g_IS_channel.resize(n_channel, 0.);
  
  w_channel_step_sum.resize(n_channel, 0.);
  w_channel_full_sum.resize(n_channel, 0.);
  //  MC_sum_w_channel.resize(n_channel, 0.);
  // ???
  w_channel_av.resize(n_channel, 0.);

  alpha_it.resize(n_alpha_steps, vector<double> (n_channel, 0.));
  diff_w.resize(n_alpha_steps, 0.);

  i_alpha_it = 0;
}

multichannel_set::multichannel_set(string _name, int _n_channel, int _n_alpha_events, int _n_alpha_steps, int _switch_minimum_weight, double _limit_minimum_weight, double _reserved_minimum_weight, int _active_optimization, int _end_optimization){
  Logger logger("multichannel_set::multichannel_set " + _name);
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  name = _name;
  n_channel = _n_channel;
  n_alpha_events = _n_alpha_events;
  n_alpha_steps = _n_alpha_steps;
  switch_minimum_weight = _switch_minimum_weight;
  limit_minimum_weight = _limit_minimum_weight;
  reserved_minimum_weight = _reserved_minimum_weight;

  active_optimization = _active_optimization;
  end_optimization = _end_optimization;


  // !!!
  //  reserved_minimum_weight = 0.001; // option to change via input ???

  if (n_channel == 1){end_optimization = 1;} // check if output has to be created immediately !!!
  //  if (n_channel == 1){end_optimization = 1;} // check if output has to be created immediately !!!

  alpha.resize(n_channel, 1. / double (n_channel));
  beta.resize(n_channel, 0.);
  beta[0] = alpha[0];
  for (int i = 1; i < beta.size(); i++){beta[i] = beta[i - 1] + alpha[i];}

  n_gen = 0;
  n_acc = 0;
  n_rej = 0;
  n_tec = 0;
  n_nan = 0;

  n_acc_channel.resize(n_channel, 0);
  n_rej_channel.resize(n_channel, 0);
  
  channel = 0;

  g_channel.resize(n_channel, 0.);
  g_IS_channel.resize(n_channel, 0.);
  
  w_channel_step_sum.resize(n_channel, 0.);
  w_channel_full_sum.resize(n_channel, 0.);
  //  MC_sum_w_channel.resize(n_channel, 0.);
  // ???
  w_channel_av.resize(n_channel, 0.);

  alpha_it.resize(n_alpha_steps, vector<double> (n_channel, 0.));
  diff_w.resize(n_alpha_steps, 0.);

  i_alpha_it = 0;

  logger << LOG_DEBUG << setw(30) << "n_channel" << " = " << n_channel << endl;
  logger << LOG_DEBUG << setw(30) << "n_alpha_events" << " = " << n_alpha_events << endl;
  logger << LOG_DEBUG << setw(30) << "n_alpha_steps" << " = " << n_alpha_steps << endl;
  logger << LOG_DEBUG << setw(30) << "switch_minimum_weight" << " = " << switch_minimum_weight << endl;
  logger << LOG_DEBUG << setw(30) << "limit_minimum_weight" << " = " << limit_minimum_weight << endl;
  logger << LOG_DEBUG << setw(30) << "reserved_minimum_weight" << " = " << reserved_minimum_weight << endl;
  logger << LOG_DEBUG << setw(30) << "active_optimization" << " = " << active_optimization << endl;
  logger << LOG_DEBUG << setw(30) << "end_optimization" << " = " << end_optimization << endl;


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}


///////////////////////
//  access elements  //
///////////////////////

///////////////
//  methods  //
///////////////
void multichannel_set::psp_MCweight_optimization(double & integrand, double & g_tot){
  Logger logger("multichannel_set::psp_MCweight_optimization" + name);
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  logger << LOG_DEBUG_VERBOSE << "active_optimization = " << active_optimization << endl;
  if (!active_optimization){return;}
  //  if (end_optimization == 0){
  n_acc++;
  n_acc_channel[channel]++;
  double w_help = pow(abs(integrand), 2) / g_tot;
  //  double w_help = pow(integrand, 2) / pow(gtot, 3); // original version
  if (w_help != w_help){// || w_help == 0.){
    logger << LOG_DEBUG << "w_help != w_help" << endl;
    logger << LOG_DEBUG << "integrand = " << integrand << endl;
    logger << LOG_DEBUG << "g_tot = " << g_tot << endl;
    for (int i_c = 0; i_c < n_channel; i_c++){logger << LOG_DEBUG << "g_channel[" << i_c << "] = " << g_channel[i_c] << endl;}
  }
  else {
    for (int i_c = 0; i_c < n_channel; i_c++){
      w_channel_step_sum[i_c] += g_channel[i_c] * w_help;
    }
  }
  //    new_MCweight_opt_call(MC_g_channel, w_channel_step_sum, abs(integrand), g_tot, MC_n_channel);
  //  }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void multichannel_set::step_MCweight_optimization(int i_acc, int i_rej){
  Logger logger("multichannel_set::step_MCweight_optimization " + name);
  logger << LOG_DEBUG << "called" << endl;
  //  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  //  logger << LOG_DEBUG << "end_optimization = " << end_optimization << endl;

  logger << LOG_DEBUG << setw(30) << "active_optimization" << " = " << active_optimization << endl;
  if (!active_optimization){return;}
    //  if (end_optimization != 0){return;}
  logger << LOG_DEBUG << "i_acc = " << i_acc << endl;
  logger << LOG_DEBUG << "n_acc = " << n_acc << endl;
  logger << LOG_DEBUG << "n_alpha_events = " << n_alpha_events << endl;
  logger << LOG_DEBUG << "n_alpha_steps = " << n_alpha_steps << endl;
  if (n_acc > n_alpha_events * n_alpha_steps){return;}
  //  if (i_acc > n_alpha_events * n_alpha_steps){return;}

  logger << LOG_DEBUG << "w_channel_full_sum.size() = " << w_channel_full_sum.size() << endl;
  logger << LOG_DEBUG << "w_channel_step_sum.size() = " << w_channel_step_sum.size() << endl;
  for (int i_c = 0; i_c < n_channel; i_c++){w_channel_full_sum[i_c] += w_channel_step_sum[i_c];}
  w_channel_step_sum = vector<double> (n_channel, 0.);

  if (n_acc % n_alpha_events != 0){return;} // needed ???
  //  if (i_acc % n_alpha_events != 0){return;} // needed ???
  //    vector<double> w_channel_av(n_channel);

  vector<double> c_w_channel_sum(n_channel);
  double c_w_norm;

  //  logger << LOG_DEBUG << "i_alpha_it = " << i_alpha_it << endl;
  //  logger << LOG_DEBUG << "alpha_it.size() = " << alpha_it.size() << endl;

  alpha_it[i_alpha_it] = alpha;

  // determination if new alpha's should be determined:

  for (int i_c = 0; i_c < n_channel; i_c++){
    logger << LOG_DEBUG << "n_acc_channel[" << i_c << "] = " << n_acc_channel[i_c] << endl;
    logger << LOG_DEBUG << "n_rej_channel[" << i_c << "] = " << n_rej_channel[i_c] << endl;
    //    logger << LOG_DEBUG << "w_channel_full_sum[" << i_c << "] = " << w_channel_full_sum[i_c] << endl;

    if (n_acc_channel[i_c] + n_rej_channel[i_c] != 0){
      //w_channel_av[i_c] = w_channel_full_sum[i_c] / (n_rej + n_acc);
      //w_channel_av[i_c] = w_channel_full_sum[i_c] / (i_rej + i_acc);
      w_channel_av[i_c] = w_channel_full_sum[i_c] / n_alpha_events; // w_channel_av and w_channel_full_sum are essentially the same - could be devided by something channel dependent instead.
      //    logger << LOG_DEBUG << "w_channel_av[" << i_c << "] = " << w_channel_av[i_c] << endl;
    }
    else {w_channel_av[i_c] = 0.;}
    c_w_channel_sum[i_c] = alpha[i_c] * sqrt(w_channel_av[i_c]);
    //    logger << LOG_DEBUG << "c_w_channel_sum[" << i_c << "] = " << c_w_channel_sum[i_c] << endl;
  }
  w_channel_full_sum = vector<double> (n_channel, 0.);
  sort(w_channel_av.begin(), w_channel_av.end());
  
  //  logger << LOG_DEBUG << "diff_w.size() = " << diff_w.size() << endl;
  diff_w[i_alpha_it] = w_channel_av[w_channel_av.size() - 1] - w_channel_av[0];
  //  logger << LOG_DEBUG << "difference = " << diff_w[i_alpha_it] << endl;
  logger << LOG_DEBUG << "i_alpha_it = " << i_alpha_it << endl;

  //  for (int i_s = 0; i_s < alpha_it.size(); i_s++){
  for (int i_s = 0; i_s < i_alpha_it + 1; i_s++){
    logger << LOG_DEBUG << "diff_w[" << setw(2) << i_s << "] = " << setprecision(15) << setw(23) << diff_w[i_s] << endl;
  }


  c_w_norm = accumulate(c_w_channel_sum.begin(), c_w_channel_sum.end(), 0.);
  logger << LOG_DEBUG << "c_w_norm = " << c_w_norm << endl;
    
  assert(!std::isnan(c_w_norm));
    
  int no_diff_w_min = 0;
  double diff_w_min = 1.E300;
  for (int i_s = 0; i_s < i_alpha_it; i_s++){
    if (diff_w[i_s] < diff_w_min){
      diff_w_min = diff_w[i_s]; 
      no_diff_w_min = i_s;
    }
  }
  counter_minimum_weight = 0;
  vector<int> no_channel_minimum_weight;
    
  if ((i_alpha_it == 0) || (diff_w[i_alpha_it] <= diff_w_min)){
    // determination of new alpha's:
    for (int i_c = 0; i_c < n_channel; i_c++){alpha[i_c] = c_w_channel_sum[i_c] / c_w_norm;}

    for (int i_c = 0; i_c < n_channel; i_c++){logger << LOG_DEBUG << "alpha[" << i_c << "] = " << alpha[i_c] << endl;}
    // switch_minimum_weight == 0: There is no minimum weight.
    // if limit_minimum_weight > 0 smaller weights are set to 0 (saves computation time).
    // set to zero only at the end of WO !!! (experiment)

    for (int i_c = 0; i_c < n_channel; i_c++){
      if (alpha[i_c] < limit_minimum_weight){ // < or <=
	alpha[i_c] = 0.;
	counter_minimum_weight++;
	if (switch_minimum_weight){no_channel_minimum_weight.push_back(i_c);}
      }
    }

    /*
    // could be combined: only difference is '<' and '<=' and "no_channel_minimum_weight" ???
   if (switch_minimum_weight == 0){
      for (int i_c = 0; i_c < n_channel; i_c++){
	if (alpha[i_c] < limit_minimum_weight){
	  alpha[i_c] = 0.;
	  counter_minimum_weight++;
	}
      }
    }
    else {
      for (int i_c = 0; i_c < n_channel; i_c++){
	if (alpha[i_c] <= limit_minimum_weight){
	  alpha[i_c] = 0.;
	  no_channel_minimum_weight.push_back(i_c);
	  counter_minimum_weight++;
	}
      }
    }
    */
    if (no_channel_minimum_weight.size() == 0){
      logger << LOG_DEBUG << "No channel set to zero because of no_channel_minimum_weight." << endl;
    }
    else {
      for (int i_m = 0; i_m < no_channel_minimum_weight.size(); i_m++){logger << LOG_DEBUG << "no_channel_minimum_weight[" << i_m << "] = " << no_channel_minimum_weight[i_m] << endl;}
    }

    //    for (int i_c = 0; i_c < n_channel; i_c++){logger << LOG_DEBUG << "alpha[" << i_c << "] = " << alpha[i_c] << endl;}

    a_reserved_min = 0.;
    if (no_channel_minimum_weight.size() != 0 && switch_minimum_weight != 0){a_reserved_min = reserved_minimum_weight;}
    double a_norm;
    a_norm = accumulate(alpha.begin(), alpha.end(), 0.) / (1. - a_reserved_min);
    for (int i_c = 0; i_c < n_channel; i_c++){if (alpha[i_c] != 0.){alpha[i_c] = alpha[i_c] / a_norm;}}
    for (int i_m = 0; i_m < no_channel_minimum_weight.size(); i_m++){alpha[no_channel_minimum_weight[i_m]] = a_reserved_min / counter_minimum_weight;}
    beta[0] = alpha[0];
    for (int i = 1; i < beta.size(); i++){beta[i] = beta[i - 1] + alpha[i];}
  }
  else {
    alpha = alpha_it[no_diff_w_min + 1];
    logger << LOG_DEBUG << "optimization step doesn't seem to improve the set of weights!" << endl;
  }
  
  i_alpha_it++;
  
  for (int i_c = 0; i_c < n_channel; i_c++){if (alpha[i_c] == 0.){g_channel[i_c] = 0.;}}
  
  for (int i_c = 0; i_c < n_channel; i_c++){logger << LOG_DEBUG << "alpha[" << i_c << "] = " << alpha[i_c] << endl;}

  logger << LOG_DEBUG << "finished" << endl;
  //  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void multichannel_set::result_MCweight_optimization(int i_acc, int i_rej, string & filename_MCweight){
  Logger logger("multichannel::result_MCweight_optimization" + name);
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (!active_optimization){return;}
  //  if (end_optimization != 0){return;}
  if (n_acc != n_alpha_events * n_alpha_steps){return;}
  //  if (i_acc != n_alpha_events * n_alpha_steps){return;}

  vector<double> vd_ch(n_channel);
  // changed from x_minimum_diff_w = 0, for (int j = 0... !!!
  x_minimum_diff_w = 0;
  //  x_minimum_diff_w = 1;

  //  for (int i_s = 0; i_s < diff_w.size(); i_s++){
  for (int i_s = 1; i_s < diff_w.size(); i_s++){
    if (diff_w[i_s] < diff_w[x_minimum_diff_w]){
      x_minimum_diff_w = i_s;
    }
  }
  alpha = alpha_it[x_minimum_diff_w];

  for (int i_c = 0; i_c < n_channel; i_c++){
    if (alpha[i_c] < limit_minimum_weight){ // < or <=
      alpha[i_c] = 0.;
      counter_minimum_weight++;
      if (switch_minimum_weight == 0){no_channel_minimum_weight.push_back(i_c);}
    }
  }

  a_reserved_min = 0.;
  if (no_channel_minimum_weight.size() != 0 && switch_minimum_weight != 0){a_reserved_min = reserved_minimum_weight;}
  double a_norm;
  a_norm = accumulate(alpha.begin(), alpha.end(), 0.) / (1. - a_reserved_min);
  for (int i_c = 0; i_c < n_channel; i_c++){if (alpha[i_c] != 0.){alpha[i_c] = alpha[i_c] / a_norm;}}
  for (int i_m = 0; i_m < no_channel_minimum_weight.size(); i_m++){alpha[no_channel_minimum_weight[i_m]] = a_reserved_min / counter_minimum_weight;}
  beta[0] = alpha[0];
  for (int i = 1; i < beta.size(); i++){beta[i] = beta[i - 1] + alpha[i];}

  /*
  if (weight_opt == 2){
    i_acc = 0;
    i_rej = 0;
    i_gen = 0;
    i_nan = 0;
    i_tec = 0;
  }
  */
  
  end_optimization = 1;
  //  ofstream out_MCweights(filename_MCweight.c_str());
  ofstream out_MCweights;
  out_MCweights.open(filename_MCweight.c_str(), ofstream::out | ofstream::app);
  out_MCweights << "# " << name << endl;
  for (int i_c = 0; i_c < n_channel; i_c++){out_MCweights << setprecision(16) << alpha[i_c] << endl;}
  out_MCweights.close();

  for (int i_s = 0; i_s < alpha_it.size(); i_s++){
    logger << LOG_DEBUG << "diff_w[" << setw(2) << i_s << "] = " << setprecision(15) << setw(23) << diff_w[i_s] << endl;
  }

  for (int i_c = 0; i_c < n_channel; i_c++){
    logger << LOG_DEBUG << "alpha[" << i_c << "] = " << alpha[i_c] << endl;
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}




void multichannel_set::output_MCweight_optimization(string & filename_MCweight){
  Logger logger("multichannel::result_MCweight_optimization" + name);
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  ofstream out_MCweights;
  out_MCweights.open(filename_MCweight.c_str(), ofstream::out | ofstream::app);
  out_MCweights << "# " << name << endl;
  for (int i_c = 0; i_c < n_channel; i_c++){out_MCweights << setprecision(16) << alpha[i_c] << endl;}
  out_MCweights.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
