      subroutine event_gen()

      include 'types.f'
!--------------------------------------------------
      include 'iterat.f'
!--------------------------------------------------
c      include 'constants.f'
      include 'ewinput.f'
      include 'masses.f'
      include 'nflav.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'kprocess.f'
      include 'zcouple.f'
      include 'breit.f'
      include 'vegas_common.f'
      include 'nproc.f'
      include 'limits.f'
      include 'nprocesses.f'
      include 'hdecaymode.f'
      include 'hbbparams.f'
      include 'nodecay.f'
      include 'mcfmparameters.f'
      include 'cuts.f'
      include 'interference.f'

      real(dp) :: integ,integ_err
      character*72 inputfile,workdir
c     integer:: itmxplots
      integer:: j,k
      real(dp):: p(mxpart,4)
      real(dp):: BrnRat
!--------> from: chooser
      common/BrnRat/BrnRat
      real(dp):: massfrun
      
      workdir=''
      call reader_input(workdir)

c----------> from chooser:
      call coupling
      nodecay=.false.
      
      if(nproc==nDY) then
         mass3=  zmass
         width3= zwidth
         n3=1
         ndim=4
         if(wsqmin == 0d0) then
            write(6,*)
            write(6,*) ''//achar(27)//'[1;31mPlease set m34min bigger than zero to'//achar(27)//'[0m'
            write(6,*) ''//achar(27)//'[1;31mprevent the virtual photon from becoming real.'//achar(27)//'[0m'
            stop
         endif
         q1=-1._dp
         l1=le
         r1=re
      elseif(nproc==nDYMY) then
         mass3=  zmass
         width3= zwidth
         n3=1
         ndim=4
         if(wsqmin == 0d0) then
             write(6,*)
             write(6,*) ''//achar(27)//'[1;31mPlease set m34min bigger than zero to'//achar(27)//'[0m'
             write(6,*) ''//achar(27)//'[1;31mprevent the virtual photon from becoming real.'//achar(27)//'[0m'
             stop
         endif
         q1=-1._dp
         l1=le
         r1=re
      elseif(nproc==nWp) then
         mass3=  wmass
         width3= wwidth
         n3=1
         ndim=4
         if(wsqmin == zip) then
            write(6,*)
            write(6,*) ''//achar(27)//'[1;31mPlease set m34min bigger than zero to'//achar(27)//'[0m'
            write(6,*) ''//achar(27)//'[1;31mprevent the virtual photon from becoming real.'//achar(27)//'[0m'
            stop
         endif
         q1=-1._dp
         l1=le
         r1=re
         call ckmfill(1)
      elseif(nproc==nWm) then
         mass3=  wmass
         width3= wwidth
         n3=1
         ndim=4
         if(wsqmin == zip) then
            write(6,*)
            write(6,*) ''//achar(27)//'[1;31mPlease set m34min bigger than zero to'//achar(27)//'[0m'
            write(6,*) ''//achar(27)//'[1;31mprevent the virtual photon from becoming real.'//achar(27)//'[0m'
            stop
         endif
         q1=-1._dp
         l1=le
         r1=re
         call ckmfill(-1)
      elseif (nproc==nH) then
         mass3=  hmass
         width3= hwidth

         if(hdecaymode.eq.'none')then
            n2=0
            n3=1  !--- wb: means we use Breit-Wigner in 'gen2m.f'
            ndim=4
            write(0,*) '                                                       '
            write(*,*) ''//achar(27)//'[1;94mProducing an on-shell Higgs boson...'//achar(27)//'[0m'
            write(0,*) '                                                       '
         elseif(hdecaymode.eq.'bqba')then
            n2=0
            n3=1  !--- wb: means we use Breit-Wigner in 'gen2m.f'
            ndim=4
            mb_eff=massfrun(mb,hmass) !-- in MCFM: massfrun(mb_msbar,hmass,amz,1)
         !LR: Following lines added, to be checked
         elseif(hdecaymode.eq.'gaga')then
            n2=0
            n3=1  
            ndim=4
         elseif(hdecaymode.eq.'tlta')then
            n2=0
            n3=1  !--- wb: means we use Breit-Wigner in 'gen2m.f'
            ndim=4
            mtau=1.77682d0      !! testtest
            mtausq=mtau**2
         elseif(hdecaymode=='ZZee'.or.hdecaymode=='ZZmm'.or.hdecaymode=='ZZem') then
            ndim=10
            n2=1
            n3=1
            mass2=zmass
            width2=zwidth
            mass3=zmass
            width3=zwidth
            interference = .true.
            l1=le
            r1=re
            l2=le
            r2=re
            if (hdecaymode=='ZZem') interference=.false.
         else 
            call unimplemented_decay
         endif


      else
         call unimplemented_process
      endif
      
!--------->integrate:      
      call mcfm_vegas(0,itmx1,ncall1,.false.,integ,integ_err)
      call mcfm_vegas(1,itmx2,ncall2,.true. ,integ,integ_err)

      if(.not.mcfm_dryrun) return
!---------> final cross-section:
      write(*,123) '***************************************************'
      write(*,123) '*                                                 *'
      write(*,123) '*  Cross-section:                                 *'
      write(*,345) integ/1d3, integ_err/1d3 
      write(*,123) '*                                                 *'
      write(*,123) '***************************************************'
 345  format('*   ',f32.16,' +/- ',f32.16,' [pb]    *')
 123  format(a)

      return
      end
