module banner 
use iso_c_binding

contains 

   subroutine print_banner() BIND(C)
      use iso_c_binding

      write(0,*) ' ___________________________________________________________________________ '
      write(0,*) '| Version: 3.0.0                                                  June 2020 |'
      write(0,*) '|                                                                           |'
      write(0,*) '|                 '//achar(27)//'[1;32m     ____           _ ___ ____  _   _     '//achar(27)//'[0m                |'
      write(0,*) '|                 '//achar(27)//'[1;32m    |  _ \ __ _  __| |_ _/ ___|| | | |    '//achar(27)//'[0m                |'
      write(0,*) '|                 '//achar(27)//'[1;32m    | |_) / _` |/ _` || |\___ \| |_| |    '//achar(27)//'[0m                |'
      write(0,*) '|                 '//achar(27)//'[1;32m    |  _ < (_| | (_| || | ___) |  _  |    '//achar(27)//'[0m                |'
      write(0,*) '|                 '//achar(27)//'[1;32m    |_| \_\__,_|\__,_|___|____/|_| |_|    '//achar(27)//'[0m                |'
      write(0,*) '|                                                                           |'
      write(0,*) '|                    '//achar(27)//'[1;1mRad'//achar(27)//'[0miation off '//achar(27)//'[1;1mI'//achar(27)//'[0mnitial '//achar(27)//'[1;1mS'//achar(27)//'[0mtate '//achar(27)//'[1;1mH'//achar(27)//'[0madrons                    |'
      write(0,*) '|       Written by W. Bizon, P. Monni, E. Re, L. Rottoli, P. Torrielli      |'
      write(0,*) '|                                                                           |'
      write(0,*) '|                              Developers:                                  |'
      write(0,*) '|                   P. Monni      (pier.monni@cern.ch)                      |'
      write(0,*) '|                   E. Re         (emanuele.re@lapth.cnrs.fr)               |'
      write(0,*) '|                   L. Rottoli    (luca.rottoli@cern.ch)                    |'
      write(0,*) '|                   P. Torrielli  (torriell@to.infn.it)                     |'
      write(0,*) '|                                                                           |'
      write(0,*) '|                Available under the GNU public license                     |'
      write(0,*) '|                                                                           |'
      write(0,*) '| If you use it or any derivative of it in scientific work you should cite  |'
      write(0,*) '| P. Monni, E. Re, P. Torrielli: Phys.Rev.Lett. 116 (2016) no.24, 242001    |'
      write(0,*) '| W. Bizon, P. Monni, E. Re, L. Rottoli, P. Torrielli: JHEP 1802 (2018) 108 |'
      write(0,*) '|                                                                           |'
      write(0,*) '| If you use it for the joint resummation of pT and pTj, please cite also   |'
      write(0,*) '| P. Monni, L. Rottoli, P. Torrielli, arXiv:1909.04704                      |'
      write(0,*) '|                                                                           |'
      write(0,*) '|                                                                           |'
      write(0,*) ' ---------------------------------------------------------------------------'

   end subroutine print_banner

   subroutine print_help

      write (0,*) ' Usage: ./radishf90 [Options]'
      write (0,*) ''
      write (0,*) ' Options: '
      write (0,*) '    '//achar(27)//'[1;1mOPTION'//achar(27)//'[0m               <description> [<default value>]'
      write (0,*) '    '//achar(27)//'[1;1m-h, -help'//achar(27)//'[0m            display this help and exit'
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1m-in'//achar(27)//'[0m                  The name of the file containing fixed-order results (required unless you are not doing'
      write (0,*) '                         a matching, see -resum-only below)'
      write (0,*) '    '//achar(27)//'[1;1m-out'//achar(27)//'[0m                 The name of the output file [/dev/stdout]	'
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1m-differential'//achar(27)//'[0m        If used, the differential distribution is returned [false]'
      write (0,*) '    '//achar(27)//'[1;1m-nocuts'//achar(27)//'[0m              If used, no cuts on the decay products are applied [false]'
      write (0,*) '    '//achar(27)//'[1;1m-radish_inclusive'//achar(27)//'[0m    If used, the boson does not decay (available for Higgs and DY production) [false]'
      write (0,*) '    '//achar(27)//'[1;1m-cross-section'//achar(27)//'[0m       If used, the cross section is returned instead of the efficiency [false]'
      write (0,*) '    '//achar(27)//'[1;1m-dynamical'//achar(27)//'[0m           Whether to used dynamical scales [false]'
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1m-order'//achar(27)//'[0m               Resummation order (1-> NLL; 2-> NNLL; 3->N3LL (ptB and phistar only)) [2]'
      write (0,*) '    '//achar(27)//'[1;1m-prime'//achar(27)//'[0m               Whether to used prime counting (available only for NLL and NNLL) [false]'
      write (0,*) '    '//achar(27)//'[1;1m-fixed_order'//achar(27)//'[0m         Order of the fixed-order integrated distribution which the resummation '
      write (0,*) '                         is matched to (1-> NLO, 2-> NNLO, 3-> N3LO (not available for joint resummation)) [2]'
      write (0,*) '    '//achar(27)//'[1;1m-scheme'//achar(27)//'[0m              Matching scheme to fixed order result (additive: R, multiplicative: multa) [multa]'
      write (0,*) '    '//achar(27)//'[1;1m-xQ'//achar(27)//'[0m                  Ratio of resummation scale Q to boson mass [0.5]'
      write (0,*) '    '//achar(27)//'[1;1m-p'//achar(27)//'[0m                   Parameter controlling the modified logarithms [4.0]'
      write (0,*) '    '
      write (0,*) '    '//achar(27)//'[1;1m-iseed'//achar(27)//'[0m               Event generator seed [1189]'
      write (0,*) '    '//achar(27)//'[1;1m-nev'//achar(27)//'[0m                 Number of events in the shower per Born point [1e3] ([1e7] if -radish_inclusive is used)'
      write (0,*) '    '//achar(27)//'[1;1m-ncall1'//achar(27)//'[0m              Number of Born events in the grid setup run [1e3]'
      write (0,*) '    '//achar(27)//'[1;1m-ncall2'//achar(27)//'[0m              Number of Born events in the main run [1e3]'
      write (0,*) '    '
      write (0,*) '    '//achar(27)//'[1;1m-observable'//achar(27)//'[0m          The observable to be resummed (ptj -> leading jet pt, ptB -> boson pt, '
      write (0,*) '                         phi -> phistar angle (DY only), JV_ptB -> boson pt with a veto on the leading jet pt, '
      write (0,*) '                         JV_ptj -> leading jet pt with a veto on the boson pt) [ptB]   '
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1m-dryrun'//achar(27)//'[0m              Whether to call only the Born-event generator (no resummation)'
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1m-resum-only'//achar(27)//'[0m          Whether to perform only the resummation without the matching to'
      write (0,*) '                         fixed order (see below)'
      write (0,*) ''
      write (0,*) ' The following information:'
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1mproc, collider, sqrts, pdf_name, M'//achar(27)//'[0m (in the Higgs case)'//achar(27)//'[1;1m, hdecay'//achar(27)//'[0m (in the Higgs case)'//achar(27)//'[1;1m, mur, muf, R, JV, mmin, mmax, etamin, etamax'//achar(27)//'[0m'
      write (0,*) ''
      write (0,*) ' should always be contained in the input file or passed trough command line, and cannot be overwritten via'
      write (0,*) ' command-line options. '
      write (0,*) ''
      write (0,*) ' It is also possible to perform just the resummation, without a matching. This is useful for example when no'
      write (0,*) ' fixed-order file is available, and one believes that the resummation alone may be informative (the NNLL/N3LL'
      write (0,*) ' resummation is often reasonably reliable on its own in the region of small pt).'
      write (0,*) ''
      write (0,*) ' The "'//achar(27)//'[1;1m-resum-only'//achar(27)//'[0m" option turns this facility on; one is then not allowed to give the "'//achar(27)//'[1;1m-in'//achar(27)//'[0m" option, and instead'
      write (0,*) ' parameters are set entirely from the command line:'
      write (0,*) ''
      write (0,*) '    OPTION               <description> [<default value>]'
      write (0,*) '    '//achar(27)//'[1;1m-proc'//achar(27)//'[0m                "H" for Higgs boson production, "DY" for Z boson production,'
      write (0,*) '                         "Wp" ("Wm") for W+ (W-) production  ["H"]'
      write (0,*) '    '//achar(27)//'[1;1m-collider'//achar(27)//'[0m            Collider type ("pp" for proton-proton, "ppbar" for '
      write (0,*) '                         proton-antiproton) [pp]'
      write (0,*) '    '//achar(27)//'[1;1m-sqrts'//achar(27)//'[0m               Centre of mass energy [13000 GeV]'
      write (0,*) '    '//achar(27)//'[1;1m-pdf_name'//achar(27)//'[0m            LHAPDF data file for the chosen pdf set [NNPDF31_nnlo_as_0118]'
      write (0,*) '    '//achar(27)//'[1;1m-pdf_member'//achar(27)//'[0m          the index of the set to use [0]'
      write (0,*) '    '//achar(27)//'[1;1m-muR'//achar(27)//'[0m                 Renormalisation scale [M] ([1])'
      write (0,*) '                         Use -xmuR to set ratio of the boson mass (useful for dynamic scales) ([1])'
      write (0,*) '    '//achar(27)//'[1;1m-muF'//achar(27)//'[0m                 Factorisation scale [M] ([1])'
      write (0,*) '                         Use -xmuF to set ratio of the boson mass (useful for dynamic scales) ([1])'
      write (0,*) '    '//achar(27)//'[1;1m-R'//achar(27)//'[0m                   Jet-radius R for ptj and double-differential resummation [0.4]'
      write (0,*) '    '//achar(27)//'[1;1m-JV'//achar(27)//'[0m                  Jet veto JV for double-differential resummation [30]'
      write (0,*) '    '//achar(27)//'[1;1m-vmin'//achar(27)//'[0m                Sets the minimum value of the resummed observable [1d0]'
      write (0,*) '    '//achar(27)//'[1;1m-vmax'//achar(27)//'[0m                Sets the maximum value of the resummed observable [300d0]. Otherwise it '
      write (0,*) '                         sets the maximum value of the resummed observable read from the input file '
      write (0,*) '    '//achar(27)//'[1;1m-nbins'//achar(27)//'[0m               Sets the number of bins in jet pt [300].'
      write (0,*) '    '//achar(27)//'[1;1m-log'//achar(27)//'[0m                 The binning in the observable is logarithmic (base e) [.false.]'
      write (0,*) '    '//achar(27)//'[1;1m-log10'//achar(27)//'[0m               The binning in the observable is logarithmic (base 10) [.false.]'
      write (0,*) '    '//achar(27)//'[1;1m-M'//achar(27)//'[0m                   In the case of Higgs production'
      write (0,*) '                         it sets the Higgs boson mass [125d0 GeV].'
      write (0,*) '                         Z boson mass cannot be set from the'
      write (0,*) '                         command line and its hard-coded value is 91.1876 GeV.'
      write (0,*) '                         Especially useful when using the option radish_inclusive'
      write (0,*) '    '//achar(27)//'[1;1m-mmin'//achar(27)//'[0m                The minimum value of the invariant mass of the boson [10 GeV]'
      write (0,*) '    '//achar(27)//'[1;1m-mmax'//achar(27)//'[0m                The maximum value of the invariant mass of the boson [sqrts]'
      write (0,*) '    '//achar(27)//'[1;1m-etamin'//achar(27)//'[0m              The minimum value of the rapidity of the boson [-1.e99]'
      write (0,*) '    '//achar(27)//'[1;1m-etamax'//achar(27)//'[0m              The maximum value of the rapidity of the boson [1.e99]'
      write (0,*) '    '//achar(27)//'[1;1m-hdecay'//achar(27)//'[0m              The decay channel for the Higgs. Can be none, gaga. [none]'
      write (0,*) ''
      write (0,*) ' The following advanced options are for debug purposes or are not fully tested and SHOULD NOT BE USED unless you know what you are doing'
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1m-use_hoppet_running'//achar(27)//'[0m            When present the running coupling is evaluated by hoppet rather than taken from LHAPDF'
      write (0,*) '    '//achar(27)//'[1;1m-fixed-flavour-scheme'//achar(27)//'[0m          When present allows one to use a fixed five flavour scheme'
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1m-print-expansion-coefficients'//achar(27)//'[0m  Whether to print the individual expansion coefficients in the output file'
      write (0,*) '    '//achar(27)//'[1;1m-print-resum-error'//achar(27)//'[0m             When present, this option allows one to print the resummed error'
      write (0,*) '    '//achar(27)//'[1;1m-analytic-expansion'//achar(27)//'[0m            Whether to use analytic expansion WITHOUT modified logarithms'
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1m-flavour1'//achar(27)//'[0m                      Decide what initial-state flavour to consider in the expansion (ONLY)'
      write (0,*) '    '//achar(27)//'[1;1m-flavour2'//achar(27)//'[0m                      Decide what initial-state flavour to consider in the expansion (ONLY)'
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1m-ptmax_over_M'//achar(27)//'[0m                  Multiplicative matching parameter (does not affect multa)'
      write (0,*) '    '//achar(27)//'[1;1m-hmult'//achar(27)//'[0m                         Multiplicative matching parameter (does not affect multa)'
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1m-yb'//achar(27)//'[0m                            Bottom yukawa modification (kappa value)'
      write (0,*) '    '//achar(27)//'[1;1m-yc'//achar(27)//'[0m                            Charm yukawa modification (kappa value)'
      write (0,*) '    '//achar(27)//'[1;1m-ys'//achar(27)//'[0m                            Strange yukawa modification (kappa value)'
      write (0,*) ''
      write (0,*) '    '//achar(27)//'[1;1m-loop-mass'//achar(27)//'[0m                     Include full dependence on heavy-quark masses in loops for H production '
      write (0,*) '                                   (none-> large mt limit,t -> top only ,t+b -> top and bottom) [none]                   '

   end subroutine print_help

end module banner
